import numpy as np
import tohil
import pymeshfix

from objarray_numpy_tools import objarray_to_nparray,nparray_to_objarray

#to create functions and variables for all tcl available ones
tcl=tohil.import_tcl()

def numpy_renumber(connectivities,old_node_ids,new_node_ids):
    fail=0
    length_connectivities=len(connectivities)
    length_old_ids=len(old_node_ids)
    length_new_ids=len(new_node_ids)
    if(length_old_ids==length_new_ids):
        max_old_id=np.max(old_node_ids)
        new_number=np.empty(max_old_id,np.int32)
        for i in range(length_old_ids) :
            new_number[old_node_ids[i]]=new_node_ids[i]
        for i in range(length_connectivities) :
            connectivities[i]=new_number[connectivities[i]]
    else:
        fail=1
    return connectivities

def my_meshfix_clean_mesh_all():
    result=0    
    node_ids,points=tcl.GiD_Info('mesh','nodes','-array2')    
    #tcl.W(node_ids)
    #tcl.W(points)
    node_ids=objarray_to_nparray(node_ids)
    points=objarray_to_nparray(points)
    max_id_nodes=node_ids[-1]
    num_nodes=node_ids.size
    nodes_renumbered_for_meshfix=False
    if (max_id_nodes != num_nodes):
        nodes_renumbered_for_meshfix=True
        new_node_ids=np.arange(num_nodes)
    
    info_elements=tuple(tcl.GiD_Info('mesh','elements','triangle','-array2'))
    if (len(info_elements)):
        #tcl.W(info_elements)
        elements_data=info_elements[0]
        element_type_ret,element_ids_original,connectivities_original,materials=elements_data
        #element_ids=objarray_to_nparray(element_ids_original)
        connectivities=objarray_to_nparray(connectivities_original)
        if (nodes_renumbered_for_meshfix):
            connectivities=numpy_renumber(connectivities,node_ids,new_node_ids)
        else:
            connectivities-=1
        num_faces=int(len(connectivities)/3)
        connectivities.resize(num_faces,3)
        #tcl.W(points)
        #tcl.W(connectivities)
        #to avoid that numpy truncate the printed representation of its arrays
        #np.set_printoptions(threshold=np.inf)
        points_clean,faces_clean=pymeshfix.clean_from_arrays(points,connectivities)
    return (nparray_to_objarray(points_clean),nparray_to_objarray(faces_clean))
