
package require dialogwin
package require snit
package require autoscroll

if { [catch { package require gid_themes } err] } {
    set exists_gid_themes 0
} else {
    set exists_gid_themes 1
}

# to be inserted in tclIndex
proc gid_groups {} {}

snit::widget gid_groups {
    option -domdoc ""
    # menu or toplevel
    option -winstyle
    option -open_over ""
    
    #     variable searchframe_opener
    variable searchframe
    variable searchcombo
    variable last_searchstring
    variable searchstring
    
    variable viewtypemenubutton
    variable viewtypemenu
    variable viewtypevar viewall
    
    variable tree
    variable buttonbox
    
    variable group_types
    variable SortColumn
    
    delegate option -frame_bg as -background to hull
    
    constructor { args } {
        
        #$win configure -frame_bg $::SystemBackground
        
        set height [font metrics SystemFont -linespace]
        if {$height < 18} { set height 18 }
        
        #set txt "[gid_groups_conds::GetProgramName] [_ Groups]"       
        
        set txt [_ "Groups"]
        label $win.f0 -background $::SystemBackgroundHi -height 1 -cursor hand2 -foreground white -text $txt -pady 2        
        #ttk::label $win.f0 -relief solid -cursor hand2 -foreground white -text $txt ;#-background $::SystemBackgroundHi 
        
        gid_groups_conds::register_popup_help $win.f0 \
            [_ "Toggle window or inline visualization"]
        
        set parent [winfo parent [winfo parent $win]]
        bind $win.f0 <1> [list gid_groups_conds::open_groups $parent toggle]
        bind $win.f0 <<Contextual>> [list gid_groups_conds::open_groups $parent toggle]
        
        #         set searchframe_opener [frame $win.f1 -background $::SystemBackgroundSearchOpener -width 8 -height 4 -cursor hand2]
        #         set searchframe [ttk::labelframe $win.f1 -text [_ "Search..."]]
        
        #         bind $win.f1 <1> [mymethod toggle_search]
        #         bind $win.f1 <<Contextual>> [mymethod toggle_search]
        
        
        #         gid_groups_conds::register_popup_help $win.f1 [_ "Toggle search view"]
        
        #         menubutton $win.f0.caption -image [cu::get_image submenu9x9] -menu $win.f0.caption.m \
            #             -bg $::SystemBackground
        #         place $win.f0.caption -relx 1 -x -5 -anchor ne -y 4
        #         set m [menu $win.f0.caption.m -tearoff 0]      
        #         
        #         $m add checkbutton -label [_ " Inside the graphical window"] -variable ::integrate_groups_win \
            #             -command [mymethod toggle_search]
        #         
        #         $m add checkbutton -label [_ "Close the groups window"] -variable ::close_groups_win \
            #             -command [mymethod close_groups_win]
        
        button $win.f0.search -image [cu::get_image search-16] -bg $::SystemBackgroundHi -relief flat \
            -command [mymethod toggle_search]
        place $win.f0.search -relx 0 -x 0 -anchor nw -y -2
        gid_groups_conds::register_popup_help $win.f0.search [_ "Search quickly in the tree"]
        
        set searchframe [ttk::labelframe $win.lb -text [_ "Search..."]]
        #         frame $win.lb.f0 -background $::SystemBackgroundSearchOpener -width 8 -height 4 -cursor hand2
        #         $win.lb configure -labelwidget $win.lb.f0
        #         gid_groups_conds::register_popup_help $win.lb.f0 [_ "Toggle search view"]
        #         bind $win.lb.f0 <1> [mymethod toggle_search]
        #         bind $win.lb.f0 <<Contextual>> [mymethod toggle_search]
        
        set cmd [mymethod search_tree full]
        ttk::button $win.lb.l1 -image [cu::get_image search-16] -style Toolbutton \
            -command "[list $win.lb.cb1 selection range 0 end]; focus $win.lb.cb1; $cmd"
        install searchcombo as ttk::combobox $win.lb.cb1 -textvariable \
            [varname searchstring] -width 4
        set viewtypemenubutton [ttk::menubutton $win.lb.mb -image \
                [list boundary_conds-16 alternate boundary_conds_yellow-16] \
                -style Toolbutton -menu $win.lb.mb.m]
        set viewtypemenu [menu $win.lb.mb.m -tearoff 0]
        
        set searchstring ""
        set last_searchstring ""
        grid $win.lb.l1 $win.lb.cb1 $win.lb.mb -sticky new
        grid configure $win.lb.cb1 -padx "0 2" -pady "0 2"
        grid configure $win.lb.mb -padx "0 2" -pady "0 0"
        grid columnconfigure $win.lb 1 -weight 1
        
        bind $win.lb.cb1 <Return> $cmd
        set cmdT "[mymethod search_tree key] ;#"
        trace add variable [varname searchstring] write $cmdT
        bind $win.lb.cb1 <Destroy> [list trace remove variable \
                [varname searchstring] write $cmdT]
        
        #frame $win.ft -background [$win cget -frame_bg]
        ttk::frame $win.ft
        
        set columns [list \
                [list 10 [_ "Groups"] left text 1] \
                [list 3 [_ "Visible"] left image 1] \
                [list 12 [_ "Type"] left text 1] \
                ]
        
        package require fulltktree
        install tree as fulltktree $win.ft.t \
            -returnhandler "[mymethod add_group];#" \
            -selecthandler2 [mymethod press2] \
            -contextualhandler [mymethod contextual_menu] \
            -editbeginhandler [mymethod rename_start] \
            -editaccepthandler [mymethod rename_end] \
            -deletehandler "[mymethod delete_group];#" \
            -draghandler [mymethod drag_and_drop] \
            -columns $columns -expand 1 -compass_background 0 \
            -selectmode extended -font SystemFont -showheader 1 \
            -indent 0 -showlines 0 -showroot 0 -showbutton 0 -showrootbutton 0 \
            -width 240 -height 240 -borderwidth 0
        
        bind $tree <ButtonRelease-1> [mymethod press1 %x %y]
        
        $tree element create e_col_rect rect -fill "" -outline black \
            -width 15 -height 6 -outlinewidth 1
        
        set S [$tree style create s_color_text -orient horizontal]
        $tree style elements $S [list e_rect e_col_rect e_text_sel \
                e_selmarker_up e_selmarker_down]
        $tree style layout $S e_col_rect -padx {2 0} -expand ns
        $tree style layout $S e_text_sel -padx {2 0} -squeeze x -expand ns \
            -iexpand ns
        if { [package vcompare [package present treectrl] 2.1] >= 0 } {
            $tree style layout $S e_text_sel -iexpand nsx -sticky w
        }
        $tree style layout $S e_rect -union [list e_col_rect e_text_sel] -iexpand nswe -ipadx 2
        
        $tree style layout $S e_selmarker_up -detach 1           
        $tree style layout $S e_selmarker_up -width 100 -height 2 -sticky nw
        $tree style layout $S e_selmarker_down -detach 1 -expand n
        $tree style layout $S e_selmarker_down -width 100 -height 2 -sticky sw 
        
        
        
        set t1 [$tree givetreectrl]
        set editable [TreeCtrl::SetEditable $t1]
        set dragimage [TreeCtrl::SetDragImage $t1]
        set sensitive [TreeCtrl::SetSensitive $t1]
        
        lappend editable [list 0 $S e_text_sel]
        lappend sensitive [list 0 $S e_text_sel e_col_rect]
        lappend dragimage [list 0 $S e_text_sel e_col_rect]
        
        TreeCtrl::SetEditable $t1 $editable
        TreeCtrl::SetDragImage $t1 $dragimage
        TreeCtrl::SetSensitive $t1 $sensitive
        
        if { $::exists_gid_themes } {
            gid_themes::ConfigureHeaders $t1
            gid_themes::ApplyHeadersConfig $t1
        }
        
        $tree column configure 1 -width 25
        $tree column configure 2 -width 70
        
        bind [$tree givetreectrl] <F1> [mymethod groups_info]
        
        install buttonbox as ttk::frame $win.bbox ;#-background [$win cget -frame_bg]
        
        set cmds [list \
                [list group_new [_ "New group"] mbb [mymethod add_group] \
                    [list \
                        [list filenew [_ "New group"] "" [mymethod add_group]] \
                        [list filenew [_ "New child group"] "" [mymethod add_group -child]] \
                        ] \
                    ] \
                [list delete [_ "Delete group"] "" [mymethod delete_group]] \
                [list --- "" "" ""] \
                [list up [_ "Move groups position"] mb [mymethod move_group_menu %W]] \
                [list --- "" "" ""] \
                [list group_assign [_ "Send entities to group"] mb [mymethod send_entities in %W]] \
                [list group_unassign [_ "Take entities out from group"] mb [mymethod send_entities out %W]] \
                [list layers [_ "Move entities to/from layers"] mb [mymethod to_from_layers_menu %W]] \
                [list --- "" "" ""] \
                [list group_draw [_ "Draw groups by color"] mb [mymethod draw_selected_groups %W]] \
                [list list [_ "List groups"] "" [mymethod list_entities]] \
                ]
        
        set col 0
        foreach i $cmds {
            lassign $i img0 help type cmd cmdList
            if { $img0 eq "---" } {
                set b [ttk::separator $win.bbox.f$col -orient vertical]
            } else {
                if { [info exists gid_groups_conds::images($img0-16)] } {
                    set img $gid_groups_conds::images($img0-16)
                } else {
                    set img [gid_themes::GetImage $img0 small_icons]
                }
                switch $type {
                    "" - mb {
                        set b [ttk::button $win.bbox.f$col -image $img \
                                -style Toolbutton]
                        if { $type eq "mb" } {
                            cu::add_down_arrow_to_image -color blue -w $b $img
                        }
                    }
                    mbb {
                        set b [cu::menubutton_button $win.bbox.f$col -image $img \
                                -menu $win.bbox.f$col.m]
                    }
                }
                set cmd [string map [list %W [list $b]] $cmd]
                switch $type {
                    "" {
                        $b configure -command $cmd
                    }
                    mb {
                        bind $b <ButtonPress-1> "$cmd ; break"
                        bind $b <Return> "$cmd ; break"
                        bind $b <space> "$cmd ; break"
                    }
                    mbb {
                        $b configure -command $cmd
                        menu $b.m -tearoff 0
                        foreach i $cmdList {
                            lassign $i img0_i help_i type_i cmd_i
                            $b.m add command -label $help_i -command $cmd_i
                            if { $img0_i ne "" } {
                                if { [info exists gid_groups_conds::images($img0_i-16)] } {
                                    set img_i $gid_groups_conds::images($img0_i-16)
                                } else {
                                    set img_i [gid_themes::GetImage $img0_i small_icons]
                                }
                                $b.m entryconfigure end -image $img_i -compound left
                            }
                        }
                    }
                }
                tooltip::tooltip $b $help
            }
            grid $b -row 0 -column $col -sticky w
            if { $img0 eq "---" } { grid configure $b -sticky nsw -pady 2 }
            incr col
        }
        grid columnconfigure $win.bbox "$col" -weight 1
        
        grid $win.f0 -sticky nwe
        #         grid $win.f1 -sticky nw
        grid $win.lb -sticky new -padx "2 1" -pady "2 0"
        grid $win.ft -sticky nsew -padx "2 1" -pady "0 2"
        grid $buttonbox -sticky nwe
        
        grid columnconfigure $win 0 -weight 1
        grid rowconfigure $win 2 -weight 1
        
        grid $tree -sticky nsew -padx 1 -pady 1
        grid configure $tree -pady "2 0"
        grid columnconfigure $win.ft 0 -weight 1
        grid rowconfigure $win.ft 0 -weight 1
        
        #         grid remove $searchframe_opener
        
        $self configurelist $args
        
        grid remove $searchframe
        $win.f0.search configure -relief flat
        
        #         if { $options(-winstyle) eq "toplevel" } {
            #             grid remove $win.f0
            #         }
    }
    onconfigure -domdoc {value} {
        set options(-domdoc) $value
        $self actualize
        if { [$tree numitems] > 1 } {
            $tree activate 1
            $tree selection add 1
            $tree selection anchor 1
        }
        focus $tree
    }
    method close_groups_win {} {
        destroy $win
    }
    method toggle_search {} {
        if { [grid info $searchframe] eq "" } {
            grid $searchframe
            focus $searchcombo
            #             grid remove $searchframe_opener
            $win.f0.search configure -relief sunken
        } else {
            grid remove $searchframe
            #             grid $searchframe_opener
            $win.f0.search configure -relief flat
        }
    }
    variable search_tree_after ""
    # what can be: full and key
    method search_tree { what } {
        after cancel $search_tree_after
        set search_tree_after [after 200 [mymethod search_tree_do $what]]
    }
    method search_tree_do { what } {
        
        after cancel $search_tree_after
        set search_tree_after ""
        
        set str [string trim $searchstring]
        
        set isexpanded 0
        foreach i [$tree item children root] {
            set isex [$self search_expand $i [gid_groups_conds::fcompare_str \
                        $searchstring]]
            if { $isex } { set isexpanded 1 }
        }
        set last_searchstring $str
        
        if { $str eq "" } { return }
        
        set values [$searchcombo cget -values]
        
        if { [set ipos [lsearch -exact $values $str]] != -1 } {
            set values [lreplace $values $ipos $ipos]
            set replaced 1
        } else { set replaced 0 }
        
        if { $what eq "full" || $replaced } {
            set values [linsert $values 0 $str]
        } elseif { $isexpanded && [string first $str [lindex $values 0]] == -1} {
            while { [string first [lindex $values 0] $str] != -1 } {
                set values [lrange $values 1 end]
            }
            set values [linsert $values 0 $str]
        }
        set values [lrange $values 0 14]
        $searchcombo configure -values $values
    }
    method search_expand { id text } {
        set txt [gid_groups_conds::fcompare_str [$tree item text $id 0]]
        
        set visible 0
        foreach id_child [$tree item children $id] {
            if { [$self search_expand $id_child $text] } {
                set visible 1
            }
        }
        if { $visible || $text eq "" || [string match *$text* $txt] } {
            set expand 1
            $tree item configure $id -visible 1
        } else {
            set expand 0
            $tree item configure $id -visible 0
        }
        return $expand
    }
    method give_short_group_name { item } {
        return [$tree item text $item 0]
    }
    method give_full_group_name { item } {
        set nameList ""
        while { $item != 0 } {
            set nameList [linsert $nameList 0 [$tree item text $item 0]]
            set item [$tree item parent $item]
        }
        set group [join $nameList //]
        set root [$options(-domdoc) documentElement]
        set xp [format_xpath {groups/group[@n=%s]} $group]
        if { [$root selectNodes $xp] eq "" } {
            set group ""
        }
        return $group
    }
    method give_full_group_name_list { itemList } {
        set ret ""
        foreach item $itemList {
            lappend ret [list $item [$self give_full_group_name $item]]
        }
        return $ret
    }
    method _give_tree_descendants { item } {
        set ret [$tree item children $item]
        foreach i $ret {
            lappend ret {*}[$self _give_tree_descendants $i]
        }
        return [lsort -integer -unique $ret]
    }
    method give_full_group_name_and_children { itemList } {
        set ret ""
        foreach item $itemList {
            lappend itemList {*}[$self _give_tree_descendants $item]
        }
        set itemList [lsort -integer -unique $itemList]
        foreach item $itemList {
            set name [$self give_full_group_name $item]
            lappend ret [list $item $name]
        }
        return $ret
    }
    method actualize {} {
        
        if { $options(-domdoc) ne "" } {
            set root [$options(-domdoc) documentElement]
            set vs [$root selectNodes string(display_options/@view_groups_search)]
            if { $vs != 1 } { $self toggle_search }
            set v [$root selectNodes string(display_options/@groups_search_values)]
            $searchcombo configure -values [split $v ,]
            
            $viewtypemenu delete 0 end
            $viewtypemenu add radiobutton -label [_ "View all"] -variable \
                [varname viewtypevar] -value "viewall" -command \
                [mymethod actualize]
            $viewtypemenu add separator
            foreach node [$root selectNodes groups_types/group_type] {
                $viewtypemenu add radiobutton -label [$node @pn] -variable \
                    [varname viewtypevar] -value [$node @pn] -command \
                    [mymethod actualize]
            }
            if { $viewtypevar eq "viewall" } {
                $viewtypemenubutton state !alternate
            } else {
                $viewtypemenubutton state alternate
            }
        }
        
        set xview [lindex [$tree xview] 0]
        set yview [lindex [$tree yview] 0]
        
        $self store_tree_state all 0
        
        $tree item delete all
        
        if { $options(-domdoc) eq "" } { return }
        
        set selected ""
        foreach id [$tree selection get] {
            lappend selected [$self give_full_group_name $id]
        }
        if { [$tree index active] != 0 } {
            set active [$self give_full_group_name active]
        } else {
            set active ""
        }
        set root [$options(-domdoc) documentElement]
        set group_types ""
        foreach node [$root selectNodes groups_types/group_type] {
            lappend group_types [$node @pn]
        }
        set nodes [$root selectNodes groups/group]
        #         if { ![llength $nodes] } {
            #             set groupsNode [$root selectNodes groups]
            #             set id [$groupsNode appendChildTag group]
            #             $id setAttribute n [_ group]1 onoff 1 color red type \
            #                 [lindex $group_types 0]
            #             set nodes [$root selectNodes groups/group]
            #         }
        
        lassign [list "" 0 1] ids level has_more_level
        set ids ""
        set level 0
        while { $has_more_level } {
            set has_more_level 0
            foreach domNode $nodes {
                if { $viewtypevar ne "viewall" && $viewtypevar ne [$domNode @type] } {
                    continue
                }
                set nameList [cu::splitx [$domNode @n] {//}]
                set parentL [join [lrange $nameList 0 $level-1] //]
                if { $parentL eq "" } {
                    set parent 0
                } elseif { [dict exists $ids $parentL] } {
                    set parent [dict get $ids $parentL]
                } else {
                    set parentLL [join [lrange $nameList 0 $level-2] //]
                    if { $parentLL eq "" } {
                        set parent 0
                    } else {
                        set parent [dict get $ids $parentLL]
                    }
                    set parent [$self add $parent [lindex $nameList $level-1] [$domNode @onoff 1] \
                            [$domNode @color blue] [$domNode @type]]
                    $tree item collapse $parent
                    dict set ids $parentL $parent
                }
                if { [llength $nameList]-1 == $level } {
                    set id [$self add $parent [lindex $nameList end] [$domNode @onoff 1] \
                            [$domNode @color blue] [$domNode @type]]
                    if { [lsearch -exact $selected [$domNode @n]] != -1 } {
                        $tree selection add $id
                    }
                    if { [$domNode @n] eq $active } {
                        $tree activate $id
                    }
                    $tree item collapse $id
                    dict set ids [$domNode @n] $id
                } elseif { [llength $nameList] >= $level } {
                    set has_more_level 1
                }
            }
            incr level   
        }
        $tree xview moveto $xview
        $tree yview moveto $yview
    }
    # what: all display_options
    method store_tree_state { { what all } { id 0 } } {
        if { $options(-domdoc) eq "" } { return }
        
        if { $what eq "all" } {
            # all by now it is not used
        }
        set root [$options(-domdoc) documentElement]
        
        set dispNode [$root selectNodes display_options]
        if { $dispNode eq "" } {
            set dispNode [$root appendChildTag display_options]
        }
        # frame_width is is stored in the conditions tree
        
        if { [grid info $searchframe] eq "" } {
            $dispNode setAttribute view_groups_search 0
        } else {
            $dispNode setAttribute view_groups_search 1
        }
        # if one search value has a comma: problems
        $dispNode setAttribute groups_search_values \
            [join [$searchcombo cget -values] ,]
    }
    
    #     method hasfocus {} {
        #         if { [focus -lastfor $tree] eq $tree } {
            #             return 1
            #         } else {
            #             return 0
            #         }
        #     }
    #     method focus {} {
        #         focus $tree
        #     }
    method givetreectrl {} {
        return [$tree givetreectrl]
    }
    proc _sort_by_images { tree id1 id2 } {
        set img1 [$tree item element cget $id1 1 e_image -image]
        set img2 [$tree item element cget $id2 1 e_image -image]
        
        if { $img1 ne "" } {
            if { $img2 ne "" } { return 0 }
            return 1
        } elseif { $img2 ne "" } {
            return -1
        } else { return 0 }
    }
    method headerinvoke { C } {
        if {$C == $SortColumn} {
            if {[$tree column cget $SortColumn -arrow] eq "down"} {
                set order -increasing
                set arrow up
            } else {
                set order -decreasing
                set arrow down
            }
        } else {
            set order -increasing
            set arrow up
            $self column configure $SortColumn -arrow none
            set SortColumn $C
        }
        $self column configure $C -arrow $arrow
        if { $C == 1 } {
            $self item sort root $order -command \
                [list _sort_by_images $tree]
        } else {
            $self item sort root $order -column $C -dictionary
        }
    }
    method contextual_menu_add_cmds { m cmdsvar } {
        upvar $cmdsvar cmds
        
        foreach "img txt cmd acc" $cmds {
            if { $img ne "" && ([info command $img] eq "" || $img ni [image names]) } {
                if { [info exists gid_groups_conds::images($img-16)] } {
                    set img $gid_groups_conds::images($img-16)
                } else {
                    set img [gid_themes::GetImage $img small_icons]
                }
            }
            if { $txt eq "-" } {
                $m add separator
            } elseif { [lindex $cmd 0] eq "-" } {
                set i 1
                while { [winfo exists $m.m$i] } { incr i }
                $m add cascade -image $img -label $txt -compound left \
                    -menu $m.m$i
                menu $m.m$i -tearoff 0
                upvar [lindex $cmd 1] [lindex $cmd 1]
                $self contextual_menu_add_cmds $m.m$i [lindex $cmd 1]
            } else {
                $m add command -image $img -label $txt -compound left \
                    -command $cmd
                if { $acc ne "" } {
                    $m entryconfigure end -accelerator $acc
                }
            }
        }
    }
    method contextual_menu { - - x y } {
        
        set cmds [list filenew [_ "New"] [mymethod add_group] "" \
                filenew [_ "New child"] [mymethod add_group -child] "" \
                "" - "" "" \
                remove [_ "Delete"] [mymethod delete_group] "" \
                queue [_ "Group info"] [mymethod groups_info] "F1" \
                queue [_ "Rename"] [mymethod rename_group_start] ""]
        
        set group_editable 1
        if { $options(-domdoc) ne "" } {
            set root [$options(-domdoc) documentElement]
            set group_editable [$root selectNodes string(groups_types/@editable)]
            if { $group_editable eq "" } { set group_editable 1 }
        }
        if { $group_editable } {
            lappend cmds queue [_ "Change type"] [mymethod change_group_type_start] ""
        }
        lappend cmds \
            queue [_ "Change color"] [mymethod change_color] "" \
            "" - "" "" \
            up [_ "Move groups position"] "- cmds5" "" \
            "" - "" "" \
            "" [_ "Select all"] [mymethod select_all] "" \
            "" [_ "List groups"] [mymethod list_entities] "" \
            "" - "" "" \
            mail_get [_ "Send entities to group"] "- cmds2" "" \
            removecomment [_ "Take entities out"] "- cmds3" "" \
            "" - "" "" \
            layers [_ "Move entitities to/from layers"] "- cmds6" "" \
            "" - "" "" \
            colorize [_ "Draw color"] "- cmds4" ""
        
        switch [lindex [GiD_Info Project] 4] {
            GEOMETRYUSE {
                set ents [list [_ "Points"] point point [_ "Lines"] line line \
                        [_ "Surfaces"] surface surface [_ "Volumes"] volume volume]
            }
            MESHUSE {
                set ents [list [_ "Nodes"] point node [_ "L Elements"] line element \
                        [_ "S Elements"] surface element \
                        [_ "V Elements"] volume element]
            }
        }
        foreach "cmds2 cmds3 cmds4" [list "" "" ""] break
        foreach "name n img" $ents {
            lappend cmds2 [gid_themes::GetImage $img small_icons] $name \
                [mymethod send_entities in "" $name $n] ""
        }
        foreach "name n img" $ents {
            lappend cmds3 [gid_themes::GetImage $img small_icons] $name \
                [mymethod send_entities out "" $name $n] ""
        }
        foreach "name n img" $ents {
            lappend cmds4 [gid_themes::GetImage $img small_icons] $name \
                [mymethod draw_selected_groups "" $name $n] ""
        }
        set cmds5 [list \
                up [_ "Move up"] [mymethod move_group up] "" \
                down [_ "Move down"] [mymethod move_group down] "" \
                top [_ "Move top"] [mymethod move_group top] "" \
                bottom [_ "Move bottom"] [mymethod move_group bottom] "" \
                ]
        set cmds6 [list \
                layers [_ "Groups from layers"]... [mymethod layers_to_groups] "" \
                layers [_ "Layers from groups"]... [mymethod groups_to_layers] "" \
                ]
        
        destroy $win.menu
        set m [menu $win.menu -tearoff 0]
        
        $self contextual_menu_add_cmds $m cmds
        tk_popup $m $x $y
    }
    method draw_selected_groups { w { ovname "" } { ov "" } } {
        set ids [$tree selection get]
        if { [llength $ids] == 0 } {
            GID_tk_messageBox -message [_ "It is necessary to select one or more groups"] -parent $w
            return
        }
        if { $ov eq "" } {
            set menu $win.menu
            destroy $menu
            menu $menu -tearoff 0
            
            switch [lindex [GiD_Info Project] 4] {
                GEOMETRYUSE {
                    set ents [list [_ "Points"] point point [_ "Lines"] line line \
                            [_ "Surfaces"] surface surface [_ "Volumes"] volume volume]
                }
                MESHUSE {
                    set ents [list [_ "Nodes"] point node [_ "L Elements"] line element \
                            [_ "S Elements"] surface element \
                            [_ "V Elements"] volume element]
                }
            }
            foreach "name n img" $ents {
                $menu add command -label $name -command \
                    [mymethod draw_selected_groups_do $w $n] -image \
                    [gid_themes::GetImage $img small_icons] -compound left
            }
            set x [expr {[winfo rootx $w]}]
            set y [expr {[winfo rooty $w]+[winfo height $w]}]
            tk_popup $menu $x $y
        } else {
            $self draw_selected_groups_do $w $ov
        }
    }
    method draw_selected_groups_do { w ov } {
        set groups ""
        foreach i [$tree selection get] {
            lappend groups [list [$self give_full_group_name $i] $ov]
        }
        if { $groups eq "" } {
            set groups [list ALL $ov]
        }
        $self end_draw_selected_groups "" ""
        gid_groups_conds::drawall colors $groups
        GiD_Process 'Redraw
        # dirty trick to make delayedop work correctly
#         GidUtils::DisableWarnLine
#         GiD_Process Mescape 'SelectEntities
#         GidUtils::EnableWarnLine
        
        if { $options(-open_over) ne "" && [winfo class $options(-open_over)] eq "Button" } {
            set b0 $options(-open_over)
            set scr ""
            append scr "[list $b0 configure -image [$b0 cget -image]];"\
                "[list $b0 configure -command [$b0 cget -command]];"\
                "[list wm deiconify [winfo toplevel $win]];"\
                "grab $win"
            $b0 configure -image $gid_groups_conds::images(locationbar_erase-22) \
                -command \
                [mymethod end_draw_selected_groups $scr $b0]
            set b $b0
            
            wm withdraw [winfo toplevel $win]
            grab release $win
        } else {
            set t [winfo toplevel $win]
            set f [frame $t.finish -bd 1 -relief groove]
            set scr "[list destroy $f]; raise $t"
            set b [ttk::button $f.b -text [_ "Finish"] -width 10 -command \
                    [mymethod end_draw_selected_groups $scr $f.b]]
            grid $b -padx 2 -pady 10 -sticky nw
            grid columnconfigure $f 0 -weight 1
            grid rowconfigure $f 0 -weight 1
            
            place $f -in $t -x 0 -y 0 -anchor nw \
                -width [winfo width $t] -height [winfo height $t]
#             grab $f
            bind $b <Escape> "[list $b invoke]; break"
            bind $b <Return> [list $b invoke]
            focus $b
        }
#         delayedop changefunc [list $b invoke]
    }
    method end_draw_selected_groups { scr b } {        
        if { $b ne "" } {
            set found [delayedop -cancel changefunc [list $b invoke]]
            if { $found } { GiD_Process Mescape }
        }
        eval $scr
        gid_groups_conds::end_drawall
    }
    method press1 { x y } {
        
        set identify [$tree identify $x $y]
        
        if { [lindex $identify 3] == 0 && [lindex $identify 5] eq "e_col_rect" } {
            $self change_color
            return 0
        } elseif { [lindex $identify 3] == 1 } {
            $self set_to_onoff
            return 0
        } else {
            return 1
        }
    }
    method press2 { args } {
        # nothing by now
    }
    method rename_start { - item col } {
        
        if { $col == 0 } {
            set values ""
            set root [$options(-domdoc) documentElement]
            foreach node [$root selectNodes groups/group] {
                lappend values [$node @n]
            }
            return [list combo 1 $values ""]
        } elseif { $col == 2 } {
            set group_editable 1
            if { $options(-domdoc) ne "" } {
                set root [$options(-domdoc) documentElement]
                set group_editable [$root selectNodes string(groups_types/@editable)]
                if { $group_editable eq "" } { set group_editable 1 }
            }
            if { $group_editable } {
                return [list combo 0 $group_types ""]
            }
        }
        return 0
    }
    method rename_end { - item col text } {
        if { $col == 0 } {
            $self rename_group $item $text
        } elseif { $col == 2 } {
            $self change_group_type $item $text
        }
    }
    # only changes the tree, not the GiD data
    method add { args } {
        
        set optional {
            { -before item "" }
            { -check_name "" 0 }
        }
        set compulsory "parent name onoff color gtype"
        parse_args $optional $compulsory $args
        
        if { $onoff } {
            set img [gid_themes::GetImage ok small_icons]
        } else {
            set img blank-16
        }
        
        set nameList [cu::splitx $name {//}]
        if { [llength $nameList] > 1 } {
            set parent [$self add -check_name $parent [join [lrange $nameList 0 end-1]] \
                    $onoff $color $gtype]
            set before ""
            set name [lindex $nameList end]
        } elseif { $check_name } {
            set found 0
            foreach item [$tree item children $parent] {
                if { $name eq [$tree item text $item 0] } {
                    set found 1
                    break
                }
            }
            if { $found } { return $item }
        }
        if { $before eq "" } {
            set treenode [$tree insert end [list $name $img $gtype] $parent]
        } else {
            set treenode [$tree insert prev [list $name $img $gtype] $before]
        }
        set colorState [list $color]
        $tree item style set $treenode 0 s_color_text
        $tree item element configure $treenode 0 e_col_rect -fill $colorState + \
            e_text_sel -text $name
        
        if { $parent != 0 } {
            $tree configure -indent 19 -showbutton 1 -showlines 0
        }
        return $treenode
    }
    # only changes the tree, not the GiD data
    method rename { treenode name { onoff "" } } {
        
        if { $onoff eq "" } {
            if { [$tree item element cget $treenode 1 e_image -image] eq [gid_themes::GetImage ok small_icons] } {
                set onoff 1
            } else {
                set onoff 0
            }
        }
        set colorState [$tree item element cget $treenode 0 e_col_rect -fill]
        set color [lindex $colorState 0]
        set type [$tree item element cget $treenode 2 e_text_sel -text]
        
        set nameList [cu::splitx $name {//}]
        if { [llength $nameList] > 1 } {
            $self add -before $treenode [$tree item parent $treenode] $name $onoff \
                $color $type
            $tree item delete $treenode
            $tree activate_select_item first
        } else {
            if { $onoff } {
                set img [gid_themes::GetImage ok small_icons]
            } else {
                set img blank-16
            }
            $tree item complex $treenode \
                [list [list e_col_rect -fill $colorState] [list e_text_sel -text $name]] \
                [list [list e_image -image $img]] \
                [list [list e_text_sel -text $type]]
        }
    }
    method add_group { args } {
        set optional {
            { -child "" 0 }
        }
        set compulsory ""
        parse_args $optional $compulsory $args
        
        $tree edit_item_cancel
        
        if { $child } {
            if { [llength [$tree selection get]] != 1 } {
                snit_messageBox -message [_ "Select one group to be the parent of the new group"] \
                    -parent $win
                return
            }
            set parent [lindex [$tree selection get] 0]
            $tree item expand $parent
            set name0 [$self give_full_group_name $parent]//[_ "group"]
        } else {
            set parent 0
            if { $::CUSTOM_LIB_USE_NATIVE_GROUPS } {
                set name0 [_ "Group"]
            } else {
                set name0 [_ "group"]
            }
        }
        lassign [gid_groups_conds::add_new_group -noactualizegroups $name0] name color
        
        set id [$self add 0 $name 1 $color [lindex $group_types 0]]
        $self rename_group_start $id
    }
    method delete_group {} {
        
        set gList [$self give_full_group_name_and_children [$tree selection get]]
        
        switch [llength $gList] {
            0 { 
                snit_messageBox -message [_ "Select at least one group to delete"] \
                    -parent $win
                return
            }
            1 {
                set txt [_ "Are you sure to delete group '%s'?" [lindex $gList 0 1]]
            }
            default {
                foreach i [lrange $gList 0 9] {
                    lassign $i item group
                    if { $group ne "" } {
                        lappend groups_pr [lindex $i 1]
                    }
                }
                if { [llength $gList] > 10 } {
                    append groups_pr "..."
                }
                set txt [_ "Are you sure to delete groups '%s' (%d)?" $groups_pr [llength $gList]]
            }
        }
        set ret [snit_messageBox -type okcancel -default ok \
                -message $txt -parent $win]
        if { $ret eq "cancel" } { return }
        
        foreach i $gList {
            lassign $i item group
            if { $group ne "" } {
                set ret [gid_groups_conds::delete_group -noactualizegroups $group]
            } else {
                set ret ""
            }
            if { $ret != "-cancel-" } {
                # catch is here because children items can already be deleted
                catch { $tree item delete $item }
            }
        }
        $tree activate_select_item first
    }
    method select_group { group_name } {
        if { $::GidPriv(ShowGroupsTab) } {
            Groups::SelectGroup $group_name
        } else {
            foreach item [$tree item children 0] {
                if { [$tree item text $item 0] eq $group_name } {
                    $tree selection clear all
                    $tree selection add $item
                    $tree activate $item
                    $tree see $item
                    focus [$tree givetreectrl]
                    break
                }
            }
        }
    }
    method change_group_type { id newtype } {
        set name [$self give_full_group_name $id]
        gid_groups_conds::change_group_att -noactualizegroups $name type $newtype
        $tree item element configure $id 2 text -text $newtype
    }
    method rename_group_start_name { group_name } {
        foreach item [$tree item children 0] {
            if { [$tree item text $item 0] eq $group_name } {
                $self rename_group_start $item
                break
            }
        }
    }
    method rename_group_start { { id "" } } {
        if { $id eq "" } { set id [$tree selection get] }
        if { [llength $id] != 1 } {
            GID_tk_messageBox -message [_ "It is necessary to select one group for renaming"] {*}[ GidUtils::GiDDefaultParentIfPresent]
            return
        }
        $tree selection clear all
        $tree selection add $id
        $tree activate $id
        $tree see $id
        focus [$tree givetreectrl]
        update
        event generate [$tree givetreectrl] <F2>
    }
    method change_group_type_start  { { id "" } } {
        if { $id eq "" } { set id [$tree selection get] }
        if { [llength $id] != 1 } {
            GID_tk_messageBox -message [_ "It is necessary to select one group for changing group type"] {*}[ GidUtils::GiDDefaultParentIfPresent]
            return
        }
        $tree selection clear all
        $tree selection add $id
        $tree activate $id
        $tree see $id
        focus [$tree givetreectrl]
        update
        $tree edit_item $id 2
    }
    method _rename_group_do { id oldnameF newnameF } {
        gid_groups_conds::rename_group -noactualizegroups $oldnameF $newnameF
        foreach id_child [$tree item children $id] {
            set oldnameList_i [cu::splitx $oldnameF {//}]
            lappend oldnameList_i [$self give_short_group_name $id_child]
            set newnameList_i [cu::splitx $newnameF {//}]
            lappend newnameList_i [$self give_short_group_name $id_child]
            $self _rename_group_do $id_child [join $oldnameList_i //] [join $newnameList_i //]
        }
    }
    method rename_group { id newname } {
        
        set oldname [$self give_full_group_name $id]
        set newnameList [lrange [cu::splitx $oldname {//}] 0 end-1]
        lappend newnameList $newname
        
        set err [catch { $self _rename_group_do $id [$self give_full_group_name $id] \
                    [join $newnameList //] } errstring]
        if { $err } {
            snit_messageBox -message [_ "Error renaming group '%s' (%s)" $oldname $errstring] \
                -parent $tree
            return
        }
        $self rename $id $newname
    }
    method move_group_menu { w } {
        
        set menu $win.menu
        destroy $menu
        menu $menu -tearoff 0
        
        set items [list \
                up [_ "Move group up"] [mymethod move_group up] \
                down [_ "Move group down"] [mymethod move_group down] \
                top [_ "Move group top"] [mymethod move_group top] \
                bottom [_ "Move group bottom"] [mymethod move_group bottom] \
                ]
        
        foreach "img txt cmd" $items {
            $menu add command -label $txt -image $gid_groups_conds::images($img-16) -compound left \
                -command $cmd
        }
        set x [expr {[winfo rootx $w]}]
        set y [expr {[winfo rooty $w]+[winfo height $w]}]
        tk_popup $menu $x $y
    }
    method drag_and_drop { - receiving_item dragged_items relative_pos } {
        $self move_group -itemList $dragged_items -relative_pos $relative_pos $receiving_item
    }
    method _move_rename_group { id sibling_name relative_pos } {
        set name [$self give_full_group_name $id]
        
        if { $relative_pos eq "center" } {
            set new_parent_nameList [cu::splitx $sibling_name {//}]
            
        } else {
            set new_parent_nameList [lrange [cu::splitx $sibling_name {//}] 0 end-1]
        }
        set old_parent_nameList [lrange [cu::splitx $name {//}] 0 end-1]
        set newnameList $new_parent_nameList
        lappend newnameList [lindex [cu::splitx $name {//}] end]
        set newname [join $newnameList //]
        if { $new_parent_nameList ne $old_parent_nameList } {
            gid_groups_conds::rename_group -noactualizegroups \
                $name $newname
        }
        switch $relative_pos {
            prev { set before_after before }
            next - center { set before_after after }
        }
        gid_groups_conds::move_group -noactualizegroups $sibling_name \
            $newname $before_after
        foreach id_child [$tree item children $id] {
            $self _move_rename_group $id_child $newname center
        }
    }
    method move_group { args } {
        
        set optional {
            { -itemList list "" }
            { -relative_pos prev|center|next|"" "" }
        }
        set compulsory "where"
        parse_args $optional $compulsory $args
        
        if { ![llength $itemList] } { set itemList [$tree selection get] }
        
        set ids ""
        foreach id $itemList {
            set found 0
            foreach idp [lrange [$tree item ancestors $id] 0 end-1] {
                if { $idp in $ids } {
                    set found 1
                    break
                }
            }
            if { !$found } { lappend ids $id }
        }
        
        switch $where {
            up {
                set sibling [$tree item prevsibling [lindex $ids 0]]
                set relative_pos prev
            }
            top {
                set sibling [$tree item firstchild 0]
                set relative_pos prev
            }
            down {
                set sibling [$tree item nextsibling [lindex $ids end]]
                set relative_pos next
            }
            bottom {
                set sibling [$tree item lastchild 0]
                set relative_pos next
            }
            default {
                set sibling $where
                if { $relative_pos eq "" } {
                    set sibling_row [lindex [$tree item rnc $sibling] 0]
                    set ids0_row [lindex [$tree item rnc [lindex $ids 0]] 0]
                    set idsend_row [lindex [$tree item rnc [lindex $ids end]] 0]
                    if { $sibling_row < $ids0_row } {
                        set relative_pos prev
                    } elseif { $sibling_row > $idsend_row } {
                        set relative_pos next
                    } else {
                        return
                    }
                }
            }
        }
        if { $sibling eq "" || [lsearch -integer $ids $sibling] != -1 } { return }
        
        if { $relative_pos eq "next" } { set ids [lreverse $ids] }
        
        set sibling_name [$self give_full_group_name $sibling]
        foreach id $ids {
            set err [catch { $self _move_rename_group $id $sibling_name $relative_pos } errstring]
            if { $err } {
                snit_messageBox -message $errstring -parent $win
                return
            }
            switch $relative_pos {
                prev {
                    $tree item prevsibling $sibling $id
                }
                next {
                    $tree item nextsibling $sibling $id 
                }
                center {
                    $tree item lastchild $sibling $id
                }
            }
        }
    }
    method change_color {} {
        
        set color [lindex [$tree item element cget active 0 e_col_rect -fill] 0]
        set color [tk_chooseColor -initialcolor $color -parent $win \
                -title [_ "Choose color"]]
        if { $color eq "" } { return }
        
        set colorState [list $color]
        
        set gList [$self give_full_group_name_and_children [$tree selection get]]
        
        foreach i $gList {
            lassign $i item group
            if { $group ne "" } {
                gid_groups_conds::change_group_att -noactualizegroups \
                    $group color $color
            }
            $tree item element configure $item 0 e_col_rect -fill $colorState
        }
    }
    method set_to_onoff {} {
        set img [$tree item element cget active 1 e_image -image]
        if { $img eq "blank-16" } {
            set img [gid_themes::GetImage ok small_icons]
            set ison 1
        } else {
            set img blank-16
            set ison 0
        }
        
        
        set gList [$self give_full_group_name_and_children [$tree selection get]]
        set gList [lsort -index 1 $gList]
        foreach i $gList {
            lassign $i item group
            if { $group ne "" } {
                gid_groups_conds::change_group_att -noactualizegroups \
                    $group onoff $ison
            }
            if { $ison } {
                set img [gid_themes::GetImage ok small_icons]
            } else {
                set img blank-16
            }
            $tree item element configure $item 1 e_image -image $img
        }
        if { $::CUSTOM_LIB_USE_NATIVE_GROUPS } {
            #nothing to do
        } else {
            GidUtils::DisableGraphics
            if { [lindex [GiD_Info Project] 4] eq "MESHUSE" } {
                set geom_mesh mesh
            } else {
                set geom_mesh geometry
            }
            if { $ison } {
                set groups ""
                set root [$options(-domdoc) documentElement]
                foreach groupNode [$root selectNodes groups/group] {
                    if { [$groupNode @onoff] == 0 } {
                        lappend groups [$groupNode @n]
                    }
                }
                set groups [lsort $groups]
                GiD_Process 'Layers BringToFrontAll Mescape
                foreach i [list point line surface volume] {
                    set ents ""
                    foreach j [GiD_Info conditions ${i}_groups $geom_mesh] {
                        lassign $j - num - group
                        if { [lsearch -exact -sorted $groups $group] != -1 } {
                            lappend ents $num
                        }
                    }
                    set ents [lsort -integer -unique $ents]
                    if { [lindex [GiD_Info Project] 4] eq "MESHUSE" } {
                        switch $i {
                            point { set etype Nodes }
                            default { set etype Elements }
                        }
                    } else {
                        set etype $i
                    }
                    # WARNING: what happens with element's faces?
                    GiD_Process Layers SendToBack ${etype}s {*}$ents escape
                }
            } else {
                foreach i [list point line surface volume] {
                    set ents ""
                    foreach j [GiD_Info conditions ${i}_groups $geom_mesh] {
                        lassign $j - num - group
                        if { [lsearch -exact -sorted -index 1 $gList $group] != -1 } {
                            lappend ents $num
                        }
                    }
                    set ents [lsort -integer -unique $ents]
                    if { [lindex [GiD_Info Project] 4] eq "MESHUSE" } {
                        switch $i {
                            point { set etype Nodes }
                            default { set etype Elements }
                        }
                    } else {
                        set etype $i
                    }
                    # WARNING: what happens with element's faces?
                    GiD_Process Layers SendToBack ${etype}s {*}$ents escape
                }
            }
            GidUtils::EnableGraphics
            GiD_Process 'Redraw
        }
    }
    method send_entities { what w { ovname "" } { ov "" } } {
        set ids [$tree selection get]
        if { [llength $ids] == 0 } {
            GID_tk_messageBox -message [_ "It is necessary to select one group"] -parent $w
            return
        }
        set gList [$self give_full_group_name_list $ids]
        if { $ov eq "" } {
            set menu $win.menu
            destroy $menu
            menu $menu -tearoff 0
            
            switch [lindex [GiD_Info Project] 4] {
                GEOMETRYUSE {
                    set ents [list [_ Points] point point [_ Lines] line line \
                            [_ Surfaces] surface surface [_ Volumes] volume volume]
                }
                MESHUSE {
                    set ents [list [_ Nodes] point node [_ "L Elements"] line element \
                            [_ "S Elements"] surface element \
                            [_ "V Elements"] volume element]
                }
            }
            foreach "name n img" $ents {
                $menu add command -label $name -command \
                    [mymethod send_entities_do $what $name $n $gList] -image \
                    [gid_themes::GetImage $img small_icons] -compound left
            }
            set x [expr {[winfo rootx $w]}]
            set y [expr {[winfo rooty $w]+[winfo height $w]}]
            tk_popup $menu $x $y
        } else {
            $self send_entities_do $what $ovname $ov $gList
        }
    }
    method send_entities_do { what ovtype_name ovtype gList } {
        
        if { [lindex [GiD_Info Project] 4] eq "MESHUSE" } {
            switch $ovtype {
                point { set ovseltype node }
                line - surface - volume { set ovseltype element }
            }
            set geom_mesh mesh
        } else {
            set ovseltype $ovtype
            set geom_mesh geometry
        }
        switch $what {
            in {
                if { [llength $gList] == 1 } {
                    set txt [_ "Select %s to add to group '%s'" \
                            $ovtype_name [lindex $gList 0 1]]
                } else {
                    set groups_pr ""
                    foreach i [lrange $gList 0 6] {
                        lappend groups_pr [lindex $gList 1]
                    }
                    if { [llength $gList] > 7 } { append groups_pr ... }
                    set txt [_ "Select %s to add to groups '%s'" \
                            $ovtype_name $groups_pr]
                }
            }
            out {
                if { [llength $gList] == 1 } {
                    set txt [_ "Select %s to delete from group '%s'" \
                            $ovtype_name [lindex $gList 0 1]]
                } else {
                    set groups_pr ""
                    foreach i [lrange $gList 0 6] {
                        lappend groups_pr [lindex $gList 1]
                    }
                    if { [llength $gList] > 7 } { append groups_pr ... }
                    
                    set txt [_ "Select %s to delete from groups '%s'" \
                            $ovtype_name $groups_pr]
                }
            }
        }
        GidUtils::SetWarnLine $txt
        GidUtils::DisableWarnLine                
        GiD_Process Mescape 'SelectEntities ${ovseltype}s            
        GidUtils::EnableWarnLine
        
        if { $options(-open_over) ne "" && [winfo class $options(-open_over)] eq "Button" } {
            set b0 $options(-open_over)
            set scr ""
            append scr "[list $b0 configure -image [$b0 cget -image]];"\
                "[list $b0 configure -command [$b0 cget -command]];"\
                "[list wm deiconify [winfo toplevel $win]];"\
                "grab $win"
            $b0 configure -image $gid_groups_conds::images(locationbar_erase-22) \
                -command \
                [mymethod end_send_entities_do $scr $b0]
            set b $b0
            
            wm withdraw [winfo toplevel $win]
            grab release $win
        } else {
            set t [winfo toplevel $win]
            set f [frame $t.finish -bd 1 -relief groove]
            set scr "[list destroy $f]; raise $t"
            set b [button $f.b -text [_ "Finish"] -width 10 -command \
                    [mymethod end_send_entities_do $scr $f.b]]
            grid $b -padx 2 -pady 10 -sticky nw
            grid columnconfigure $f 0 -weight 1
            grid rowconfigure $f 0 -weight 1
            
            place $f -in $t -x 0 -y 0 -anchor nw -width \
                [winfo width $t] -height [winfo height $t]
            grab $f
            bind $b <Escape> "[list $b invoke]; break"
            bind $b <Return> [list $b invoke]
            focus $b
        }
        delayedop changefunc [list $b invoke]
        vwait ::GidPriv(selection)
        set entities [lrange [lindex $::GidPriv(selection) 0] 1 end]
        
        switch $what {
            in {
                gid_groups_conds::add_entities_to_groups $entities $gList $ovtype
                #$self _add_entities_to_groups $entities $groups $ovtype $geom_mesh
            }
            out {
                gid_groups_conds::delete_entities_from_groups $entities $gList $ovtype
                #$self _delete_entities_from_groups $entities $groups $ovtype $geom_mesh
            }
        }
    }
    method end_send_entities_do { scr b } {
        
        set found [delayedop -cancel changefunc [list $b invoke]]
        if { $found } { GiD_Process escape }
        
        eval $scr
        # GiD_Process Redraw
    }
    method groups_info_check {} {
        if { [gid_groups_conds::is_popup_help_active $tree] } {
            $self groups_info
        }
    }
    method groups_info {} {
        set gList [$self give_full_group_name_and_children [$tree selection get]]
        if { ![llength $gList] } { return }
        
        if { $::CUSTOM_LIB_USE_NATIVE_GROUPS } {
            #count after
        } else {
            foreach geommesh [list geometry mesh] {
                foreach ovtype [list point line surface volume] {
                    foreach g $gList {
                        set group [lindex $g 1]
                        if { $group ne "" } {
                            set num_ents($geommesh,$ovtype,$group) 0
                        }
                    }
                    foreach j [GiD_Info conditions ${ovtype}_groups $geommesh] {
                        lassign $j - num - group
                        if { [lsearch -exact -index 1 $gList $group] == -1 } { continue }
                        incr num_ents($geommesh,$ovtype,$group)
                    }
                }
            }
        }
        set root [$options(-domdoc) documentElement]
        set text ""
        set line 0
        foreach g $gList {
            lassign $g - group
            if { $group eq "" } { continue }
            if { $text ne "" } { append text "\n\n" }
            append text "[_ "group"]: $group"
            set lineL 2
            
            if { $::CUSTOM_LIB_USE_NATIVE_GROUPS } {
                foreach {name ovtype} [list [_ "Points"] point [_ "Lines"] line [_ "Surfaces"] surface  [_ "Volumes"] volume \
                        [_ "Nodes"] node [_ "Elements"] element [_ "Faces"] face] {
                    set count [GiD_EntitiesGroups get $group ${ovtype}s -count]
                    if { $count } {
                        append text "\n\t# $name: $count" 
                        incr lineL
                    }
                }
            } else {                
                foreach {name ovtype} [list [_ "Points"] point [_ "Lines"] line [_ "Surfaces"] surface  [_ "Volumes"] volume] {
                    if { $num_ents(geometry,$ovtype,$group) > 0 } {
                        append text "\n\t# $name: $num_ents(geometry,$ovtype,$group)" 
                        incr lineL
                    }
                }
                if { $num_ents(mesh,point,$group) > 0 } {
                    append text "\n\t# [_ "Nodes"]: $num_ents(mesh,point,$group)" 
                    incr lineL
                }
                if { $num_ents(mesh,line,$group) > 0 || $num_ents(mesh,surface,$group) > 0 || \
                    $num_ents(mesh,volume,$group) > 0} {
                    set num [expr {$num_ents(mesh,line,$group)+$num_ents(mesh,surface,$group)+\
                            $num_ents(mesh,volume,$group)}]
                    append text "\n\t# [_ "Elements"]: $num" 
                    incr lineL
                }
            }
            if { $lineL == 2 } {
                append text [concat "\n\t" [_ "No entities"]]
                incr lineL
            }
            
            set cndnum 0
            set xp [format_xpath {//condition/group[@n=%s]} $group]
            foreach grpNode [$root selectNodes $xp] {
                if { [$grpNode selectNodes {ancestor::blockdata[@n="Internal data"]}] ne "" } { continue }
                if { !$cndnum } {
                    append text [concat "\n" [_ "Applied to conditions"]:]
                    incr lineL
                }
                append text "\n\t[[$grpNode parentNode] @pn]"
                incr lineL
                incr cndnum
            }
            incr line $lineL
            if { $line > 20 } {
                append text "\n\t..."
                break
            }
        }
        lassign [$tree item bbox [lindex $gList 0 0] 0 e_text_sel] x1 y1 x2 y2
        set x [expr {[winfo rootx $tree]+$x1+10}]
        set y [expr {[winfo rooty $tree]+$y2+4}]
        
        #         set x [expr {[winfo pointerx $tree]+15}]
        #         set y [expr {[winfo pointery $tree]+10}]
        
        gid_groups_conds::popup_help -minimum_time 2000 $tree $text $x $y
    }
    method list_entities {} {        
        set gList [$self give_full_group_name_and_children [$tree selection get]]
        if { ![llength $gList] } { return }
        
        #gid_groups_conds::list_entities $win $groups
        
        set gList [lsort -index 1 $gList]
        set domNodes ""
        foreach domNode [$options(-domdoc) selectNodes /*/groups/group] {
            if { [lsearch -sorted -index 1 $gList [$domNode @n]] != -1 } {
                lappend domNodes $domNode
            }
        }
        gid_groups_conds::list_entities_cnd $win $domNodes        
    }
    method select_all {} {
        $tree selection add all
    }
    method to_from_layers_menu { w } {
        set menu $win.menu
        destroy $menu
        menu $menu -tearoff 0
        
        set items [list \
                layers [_ "Layers to groups"]... [mymethod layers_to_groups] \
                groups [_ "Groups to layers"]... [mymethod groups_to_layers] \
                ]
        
        foreach "img txt cmd" $items {
            $menu add command -label $txt -image [gid_themes::GetImage $img small_icons] -compound left \
                -command $cmd
        }
        update
        set x [expr {[winfo rootx $w]}]
        set y [expr {[winfo rooty $w]+[winfo height $w]}]
        tk_popup $menu $x $y
    }
    method layers_to_groups {} {
        
        set txt [_ "Are you sure to create a group for every layer and add the layer geometrical/mesh entities into the group?"]
        set ret [snit_messageBox -type okcancel -default ok \
                -message $txt -parent $win]
        if { $ret == "cancel" } { return }
        
        gid_groups_conds::layers_to_groups
        
        $self actualize
    }
    method groups_to_layers {} {
        set gList [$self give_full_group_name_and_children [$tree selection get]]
        set num [llength $gList]
        set txt [_ "Are you sure to create a layer for every selected group (%d groups) and add the group geometrical/mesh entities into the layer?" \
                $num]
        set ret [snit_messageBox -type okcancel -default ok \
                -message $txt -parent $win]
        if { $ret eq "cancel" } { return }
        
        if { $::CUSTOM_LIB_USE_NATIVE_GROUPS } {
            set group_names [list]
            foreach igroup $gList {
                lassign $igroup treenode group_name
                if { $group_name eq "" } { continue } 
                lappend group_names $group_name   
            }
            Groups::GroupsToLayers $group_names
        }  else {
            GidUtils::DisableGraphics
            
            set frozen_layers [gid_groups_conds::_unfreeze_layers]
            set infoProj [GiD_Info Project ViewMode]
            
            foreach i $gList {
                lassign $i treenode group
                if { $group eq "" } { continue }
                if { $group ni [GiD_Layers list] } {
                    GiD_Process Layers New $group escape                
                    set group_color [lindex [$tree item element cget $treenode 0 e_col_rect -fill] 0]        
                    scan $group_color #%2x%2x%2x rrr ggg bbb
                    set layer_color [winfo rgb $tree $group_color]
                    set rrr [expr [lindex $layer_color 0]*255/65535]
                    set ggg [expr [lindex $layer_color 1]*255/65535]
                    set bbb [expr [lindex $layer_color 2]*255/65535]
                    set layer_color [format %03i%03i%03i $rrr $ggg $bbb]
                    GiD_Process Layers Color $group $layer_color escape
                }
                foreach geom_mesh [list geometry mesh] {
                    if { $infoProj eq "GEOMETRYUSE" && $geom_mesh eq "mesh" } {
                        MeshView 0                     
                    } elseif { $infoProj eq "MESHUSE" && $geom_mesh eq "geometry" } {
                        GeometryView                       
                    }
                    foreach i [list point line surface volume] {
                        set entities ""
                        foreach j [GiD_Info conditions ${i}_groups $geom_mesh] {
                            lassign $j num face - gr
                            if { $num in "E N" } {
                                set num $face
                            } else {
                                set num ""
                            }
                            if { $gr eq $group && $num ne "" } {
                                lappend entities $num
                            }
                        }
                        if { $entities != "" } {
                            GiD_Process Layers Entities $group $i {*}$entities escape
                        }
                    }
                    if { $infoProj eq "GEOMETRYUSE" && $geom_mesh eq "mesh" } {
                        GeometryView                       
                    } elseif { $infoProj eq "MESHUSE" && $geom_mesh eq "geometry" } {
                        MeshView 0                                               
                    }
                }
            }            
            gid_groups_conds::_freeze_layers $frozen_layers
            GidUtils::EnableGraphics
            GidUtils::UpdateWindow LAYER    
        }
    }
}
