
################################################################################
#    Reports
################################################################################


package provide customLib::reports 1.20


# proc gid_groups_conds::_output_container_table { sNode containerNode title } {
# 
#     $sNode appendXML "<para><emphasis role='header'
#         >[xml_map $title]</emphasis></para>"
#     set tNode [$sNode appendChildTag table [list attributes() \
#                 tabstyle greenbg  cols_justify "left left"]]
#     foreach vNode [$containerNode selectNodes value] {
#         set v [gid_groups_conds::give_printable_value $vNode]
#         $tNode appendXML "<row><entry>[xml_map [$vNode @pn]]</entry
#             ><entry>[xml_map $v]</entry></row>"
#     }
# }
# 
# proc gid_groups_conds::_output_condition_table { sNode conditionNode title } {
# 
#     $sNode appendXML "<para><emphasis role='header'
#         >[xml_map $title]</emphasis></para>"
# 
#     set cols [list [= group]]
#     foreach vNode [$conditionNode selectNodes value|container/value] {
#         lappend cols [$vNode @pn]
#     }
#     set cols_justify [lrepeat [llength $cols] left]
#     set tNode [$sNode appendChildTag table [list attributes() \
#                 tabstyle greenbg  cols_justify $cols_justify]]
# 
#     set rNode [$tNode appendChildTag row]
#     foreach col $cols {
#         $rNode appendChildTag entry emphasis [list attributes() \
#                 role strong] [list text() $col]
#     }
#     foreach gNode [$conditionNode selectNodes group] {
#         set rNode [$tNode appendChildTag row]
#         $rNode appendChildTag entry [list text() [$gNode @n]]
#         foreach vNode [$gNode selectNodes .//value] {
#             set v [gid_groups_conds::give_printable_value $vNode]
#             $rNode appendChildTag entry [list text() $v]
#         }
#     }
# }

namespace eval gid_groups_conds {}

proc gid_groups_conds::_get_view_state {} {
    variable is_draw_post
    
    if { !$is_draw_post } {
	return [_get_GiD_view_state]
    } else {
	return [draw_post::give_current_view_full -with_atts]
    }
}

proc gid_groups_conds::_set_view_state { state } {
    variable is_draw_post
    
    if { !$is_draw_post } {
	_set_GiD_view_state
    } else {
	draw_full::set_view $state
    }
}

proc gid_groups_conds::_get_GiD_view_state {} {
    
    set state ""
    
    set ip [GiD_Info Project]
    set prepost [lindex $ip 4]
    dict set state prepost [lindex $ip 4] ;#GEOMETRYUSE,MESHUSE,POSTUSE or GRAFUSE
    dict set state view [GiD_Info view]
    set tmpdir [lindex $ip 9]
    
    if { $prepost eq "GEOMETRYUSE" || $prepost eq "MESHUSE" } {
	set ispre 1
    } else { set ispre 0 }
    
    if { $ispre } {
	foreach i [GiD_Info Layers] {
	    dict set state layers $i [GiD_Info Layers $i]
	}
	dict set state draw_nodes_state [give_draw_nodes_state]
    } else {
	dict set state post [give_post_state]
    }
    dict set state gid_width [winfo width .gid.central.s]
    dict set state gid_height [winfo height .gid.central.s]

    return $state
}

proc gid_groups_conds::_set_GiD_view_state { state } {
    variable doc
    
    set root [$doc documentElement]
    
    # not used by now
    #dict set state gid_width [winfo width .gid.central.s]
    #dict set state gid_height [winfo height .gid.central.s]
    
    GiD_Process MEscape
    
    set ip [GiD_Info Project]
    set prepost [lindex $ip 4]
    switch [dict get $state prepost] {
	GEOMETRYUSE {
	    switch $prepost {
		POSTUSE - GRAFUSE { GiD_Process MEscape Preprocess Yes }
		MESHUSE { GiD_Process MEscape Geometry }
	    }
	    set ispre 1
	}
	MESHUSE {
	    switch $prepost {
		POSTUSE - GRAFUSE { GiD_Process MEscape Preprocess Yes }
		GEOMETRYUSE { GiD_Process MEscape Meshing MeshView }
	    }
	    set ispre 1
	}
	POSTUSE - GRAFUSE {
	    switch $prepost {
		GEOMETRYUSE - MESHUSE { GiD_Process MEscape Postprocess }
	    }
	    set ispre 0
	}
    }
    GidUtils::DisableGraphics

    GiD_Process SetView [dict get $state view]
    
    if { $ispre } {
	foreach "n v" [dict get $state layers] {
	    if { [lsearch -exact [GiD_Info Layers] $n] == -1 } {
		GiD_Process Layers New $n escape
		foreach "on_c frozen_c r_c g_c b_c" [GiD_Info Layers $n] break
		foreach "on frozen r g b" $v break
		if { $on && !$on_c } {
		    GiD_Process Layers On $n
		} elseif { !$on && $on_c } {
		    GiD_Process Layers Off $n
		}
		if { $frozen && !$frozen_c } {
		    GiD_Process Layers Freeze $n
		} elseif { !$frozen && $frozen_c } {
		    GiD_Process Layers UnFreeze $n
		}
		GiD_Process Layers Color $n [format %03d%03d%03d $r $g $b]
	    }
	}
	set_draw_nodes_state [dict get $state draw_nodes_state]
    } else {
	set_post_state [dict get $state post]
    }
    GidUtils::EnableGraphics
    GiD_Process 'Redraw
}

proc gid_groups_conds::give_post_state {} {
#         set values [list results_options all_volumesets all_surfacesets all_cutsets \
#                 cur_volumesets cur_surfacesets cur_cutsets all_display_styles \
#                 cur_display_style all_analysis all_setps cur_analysis cur_step \
#                 all_results_views all_graphs_views cur_results_view cur_results_list \
#                 results_list cur_result cur_components_list components_list cur_component \
#                 main_geom_state main_geom_factor main_geom_all_deform main_geom_cur_deform \
#                 show_geom_state show_geom_factor show_geom_all_deform show_geom_cur_deform \
#                 show_geom_cur_analysis show_geom_cur_step   ]
    
    set values [list cur_analisis {cur_step $cur_analisis} cur_result cur_results_view \
	    cur_component main_geom_state main_geom_cur_deform]
    
    lappend values \
	{cur_vector_factor $cur_results_view $cur_result $cur_analisis $cur_step} \
	{cur_diagram_factor(component) $cur_result $cur_component $cur_analisis $cur_step} \
	{cur_diagram_factor(no_component) $cur_result $cur_analisis $cur_step} \
	{cur_result_surface_factor $cur_results_view $cur_result $cur_component $cur_analisis $cur_step} \
	{main_geom_factor $cur_analisis $cur_step $main_geom_cur_deform}
    
    lappend values cur_display_style

    set d ""
    foreach i $values {
	regexp {^[^()]+} [lindex $i 0] n0
	set n [lindex $i 0]
	set args [subst $i]
	lset args 0 $n0
	set err [catch { eval GiD_Info postprocess get $args } $n]
	if { !$err } {
	    dict set d $n [set $n]
	}
    }
    
    foreach i [list volume surface cut] {
	set all [lsort [GiD_Info postprocess get all_${i}sets]]
	set cur [lsort [GiD_Info postprocess get cur_${i}sets]]
	set non ""
	foreach j $all {
	    if { [lsearch -exact -sorted $cur $j] == -1 } {
		lappend non $j
	    }
	}
	dict set d non_cur_${i}sets $non
    }
    return $d
}

proc gid_groups_conds::set_post_state { dict } {
    
    set maps {
	No_Result "Geometry NoResults"
	Contour_Fill ContourFill
	Smooth_Contour_Fill SmoothContourFill
	Contour_Lines ContourLines
	Contour_Ranges ContourRanges
	Display_Vectors DisplayVectors
	Sh_Min_Max ShMinMax
	Result_Surface ResultSurface
	Scalar_Line_Diagram "LineDiagram ScalarDiagram" 
	Vector_Line_Diagram "LineDiagram VectorDiagram"
	Lamin_Results "Laminates"
    }
    
    set a [dict get $dict cur_analisis]
    set s [dict get $dict cur_step]
    set r_def [dict get $dict main_geom_cur_deform]
    set result_type [dict get $dict cur_results_view]
    set r [dict get $dict cur_result]
    set c [dict get $dict cur_component]
    
    GiD_Process MEscape Results AnalysisSel $a $s escape escape
    GiD_Process MEscape Results Geometry NoResults Geometry Original
    
    GiD_Process MEscape DisplayStyle [dict get $dict cur_display_style]
    
    foreach i [list volume surface cut] {
	set all [lsort [GiD_Info postprocess get all_${i}sets]]
	set cur [lsort [GiD_Info postprocess get cur_${i}sets]]
	set non [dict get $dict non_cur_${i}sets]
	foreach j $all {
	    set cur_idx [lsearch -exact -sorted $cur $j]
	    set non_idx [lsearch -exact -sorted $non $j]
	    set toggle 0
	    if { $non_idx == -1 && $cur_idx == -1 } { set toggle 1 }
	    if { $non_idx != -1 && $cur_idx != -1 } { set toggle 1 }
	    if { $toggle } { GiD_Process MEscape Select ${i}sets $j escape }
	}
    }

    if { [dict get $dict main_geom_state] eq "Deformed" } {
	set f [dict get $dict main_geom_factor]
	GiD_Process MEscape Results Geometry Deformation $r_def $f escape
	
    }
    
    set list [string map $maps $result_type]
    switch $result_type {
	Contour_Fill - Smooth_Contour_Fill - Contour_Lines - Contour_Ranges - \
	    Sh_Min_Max - Scalar_Line_Diagram {
	    if { $c eq "" } {
		set csList [GiD_Info postprocess get components_list $result_type \
		        $r $a $s]
		set c [lindex $csList end]
	    }
	    lappend list $r $c
	    if { $result_type eq "Scalar_Line_Diagram" } {
		lappend list [dict get $dict cur_diagram_factor(component)]
	    }
	}
	Display_Vectors {
	    set csList [GiD_Info postprocess get components_list \
		    Display_Vectors $r $a $s]
	    if { $c ne "" && [lsearch -exact $csList $c] == -1 } {
		set csListCF [GiD_Info postprocess get components_list \
		        Contour_Fill $r $a $s]
		set ipos [lsearch -glob $csListCF $c*]
		set c [lindex $csList $ipos]
	    } elseif { [llength $csList] == 3 } {
		if { $c eq "" } {
		    set c All
		} else {
		    set ipos [lsearch -exact $csList $c]
		    set c [lindex "X' Y' Z' All" $ipos]
		}
	    } elseif { $c eq "" } {
		set c [lindex $csList end]
	    }
	    set f [dict get $dict cur_vector_factor]
	    lappend list $r $c $f
	}
	Vector_Line_Diagram {
	    set f [dict get $dict cur_diagram_factor(no_component)]
	    lappend list $r
	}
	No_Result { set list "" }
    }
    if { $list ne "" } {
	eval [list GiD_Process MEscape Results] $list
    }
}

proc gid_groups_conds::create_report_part { ndoc part_name page_id args } {
    variable is_draw_post
    
    set date [clock format [clock seconds] -format "%Y-%m-%d"]
    set comment [_ "Created automatically at %s" $date]
    
    set retNodes ""
    switch -- $part_name {
	first_page {
	    set sNode [lindex $args 0]
	    set model_name [gid_groups_conds::give_model_name]
	    set project [file tail $model_name.gid]
	    if {$sNode eq ""} {
		set title [file tail $model_name]
	    } else {
		set rNode [$sNode parentNode]
		set title [get_domnode_attribute $rNode title]
		if { $title eq "" } {
		    $rNode setAttribute title [file tail $model_name]
		}
	    }
	    set domNode [$ndoc createElement table]
	    $domNode setAttribute tabstyle greenbg font-size 8
	    $domNode appendXML "<row><entry>[xml_map [_ "Report name"]]</entry
		><entry>[xml_map $model_name]</entry></row>"
	    
	    $domNode appendXML "<row><entry>[xml_map [_ "Creation date"]]</entry
		><entry>[xml_map $date]</entry></row>"
	    $domNode appendChildTag user_defined [list attributes() n0 gidr \
		    comment $comment page_id $page_id n first_page]
	    lappend retNodes $domNode
	}
	container_table {
	    set containerNode [lindex $args 0]
	    set domNode [$ndoc createElement table]
	    $domNode setAttribute tabstyle greenbg cols_justify "left left" font-size 8

	    set has_values 0
	    foreach vNode [$containerNode selectNodes value] {
		set state [get_domnode_attribute $vNode state]
		if { $state eq "hidden" } { continue }
		set v [gid_groups_conds::give_printable_value $vNode]
		set pn [get_domnode_attribute $vNode pn]
		if { $pn eq "" } { set pn [$vNode @n] }
		$domNode appendXML "<row><entry>[xml_map $pn]</entry
		    ><entry>[xml_map $v]</entry></row>"
		incr has_values
	    }
	    if { $has_values } {
		$domNode appendChildTag user_defined [list attributes() n0 gidr \
		        comment $comment n container_table page_id $page_id \
		        xpath [gid_groups_conds::nice_xpath $containerNode]]
		lappend retNodes $domNode
	    } else {
		$domNode delete
	    }
	    
	    set xp {.//edit_command}
	    foreach edit_commandNode [$containerNode selectNodes $xp] {
		set proc_print_xml [get_domnode_attribute $edit_commandNode proc_print_xml]
		if { $proc_print_xml eq "" } { continue }
		set xml [gid_groups_conds::eval_proc $proc_print_xml $edit_commandNode]
		set doc_edit [dom parse $xml]
		set domNode [$doc_edit documentElement]
		$domNode appendChildTag user_defined [list attributes() n0 gidr \
		        comment $comment n container_table page_id $page_id \
		        xpath [gid_groups_conds::nice_xpath $containerNode]]
		lappend retNodes $domNode
	    }
	}
	condition_table {
	    set conditionNode [lindex $args 0]

	    set cols [list [= group]]
	    foreach vNode [$conditionNode selectNodes value|container/value] {
		set state [get_domnode_attribute $vNode state]
		if { $state eq "hidden" } { continue }
		set pn [get_domnode_attribute $vNode pn]
		if { $pn eq "" } { set pn [$vNode @n] }
		lappend cols $pn
	    }
	    set cols_justify [lrepeat [llength $cols] left]

	    set domNode [$ndoc createElement table]
	    $domNode setAttribute tabstyle greenbg cols_justify $cols_justify font-size 8

	    set rNode [$domNode appendChildTag row]
	    foreach col $cols {
		$rNode appendChildTag entry emphasis [list attributes() \
		        role strong] [list text() $col]
	    }
	    foreach gNode [$conditionNode selectNodes group] {
		set rNode [$domNode appendChildTag row]
		$rNode appendChildTag entry [list text() [$gNode @n]]
		foreach vNode [$gNode selectNodes .//value] {
		    set state [get_domnode_attribute $vNode state]                                        
		    set parentNode [$vNode parentNode]
		    if {[$parentNode nodeName] == "functionVariable" || $state eq "hidden"} {
		        continue
		    }                                                                               
		    if {[$vNode selectNodes .//function/functionVariable] != ""} {
		        set v function                                               
		    } else {                      
		        set v [gid_groups_conds::give_printable_value $vNode]                                               
		    }                   
		    $rNode appendChildTag entry [list text() $v]
		}                                
	    }                                                  
	    $domNode appendChildTag user_defined [list attributes() n0 gidr \
		    comment $comment n condition_table page_id $page_id \
		    xpath [gid_groups_conds::nice_xpath $conditionNode]]   
	    lappend retNodes $domNode   
	}        
	current_view {
	    set state [lindex $args 0]
	    if { $state ne "" } {
		_set_view_state [lindex $args 0]
	    }
	    if { $::tcl_platform(platform) eq "windows" } {
		GiD_Process Hardcopy CopyClipboard
		set img [cu::img::clipboard get -type tclimage]
	    } else {
		set tfile [cu::file::tempfile gidg .png]
		GiD_Process Hardcopy PNG $tfile
		set img [image create photo -file $tfile]
		file delete $tfile
	    }
	    set mtype image/png
	    set err [catch {$img data -format png} data]
	    if { $err } {
		set mtype image/jpeg
		set data [$img data -format jpeg]
	    }			    
		set data [binary encode base64 -maxlen 60 $data]	    
	    image delete $img
	    
	    set domNode [$ndoc createElement mediaobject]

	    set xml "<imageobject><imagedata "
	    append xml "fileref='[xml_map "data:$mtype;base64,$data"]' "
	    append xml "></imagedata></imageobject>"

	    $domNode appendXML $xml
	    
	    set gNode [$domNode appendChildTag user_defined [list attributes() n0 gidr \
		        comment $comment n current_view]]

	    if { !$is_draw_post } {
		dict for "n v" [_get_view_state] {
		    $gNode appendXML "<$n>[xml_map $v]</$n>"
		}
	    } else {
		$gNode appendXML "<view>[xml_map [_get_view_state]]</view>"
	    }
	    lappend retNodes $domNode
	}
	reports_post {
	    set dict [lindex $args 0]
	    foreach "namesDict data" [reports_post_give_data $dict] break
	    set headers [lindex $data 0]
	    set rows [lrange $data 1 end]

	    set domNode [$ndoc createElement table]
	    $domNode setAttribute tabstyle spreadsheet

	    set rNode [$domNode appendChildTag row]
	    foreach col $headers {
		$rNode appendChildTag entry emphasis [list attributes() \
		        role strong] [list text() $col]
	    }
	    foreach row $rows {
		set rNode [$domNode appendChildTag row]
		foreach col $row {
		    $rNode appendChildTag entry [list text() $col]
		}
	    }
	    set udNode [$domNode appendChildTag user_defined [list attributes() n0 gidr \
		        comment $comment n reports_post page_id $page_id]]
	    _reports_post_win_from_dict_to_xml $dict $udNode
	    lappend retNodes $domNode
	    
	    if { [dict exists $dict create_abbrev_table] } {
		set domNode [$ndoc createElement table]
		$domNode setAttribute tabstyle greenbg cols_justify "left left" \
		    relativesizes "10 15 10"
		lappend retNodes $domNode

		set rNode [$domNode appendChildTag row]
		$rNode appendChildTag entry emphasis [list attributes() \
		        role strong] [list text() [= Name]]
		$rNode appendChildTag entry emphasis [list attributes() \
		        role strong] [list text() [= Abbr]]

		dict for "n v" $namesDict {
		    set rNode [$domNode appendChildTag row]
		    $rNode appendChildTag entry [list text() $n]
		    $rNode appendChildTag entry [list text() $v]
		}
		lappend retNodes $domNode
	    }
	}
	list_entities {
	    lassign [lrange $args 0 1] domNodes geom_mesh
	    lassign [gid_groups_conds::list_entities_give_data_full $domNodes $geom_mesh] columnList cndList rows           
	    if { [llength $cndList] < 2 } {
		set columnList [lrange $columnList 1 end]
		set first_col_out 1
	    } else {
		set first_col_out 0   
	    }

	    set domNode [$ndoc createElement table]
	    $domNode setAttribute tabstyle spreadsheet

	    set rNode [$domNode appendChildTag row]
	    foreach col $columnList {
		$rNode appendChildTag entry emphasis [list attributes() \
		        role strong] [list text() $col]
	    }
	    foreach row $rows {
		if { $first_col_out } { set row [lrange $row 1 end] }
		set rNode [$domNode appendChildTag row]
		foreach col $row {
		    $rNode appendChildTag entry [list text() $col]
		}
	    }
	    
	    set udNode [$domNode appendChildTag user_defined [list attributes() n0 gidr \
		        comment $comment n list_entities page_id $page_id]]
		      
	    _list_entities_from_data_to_xml $domNodes $geom_mesh $udNode
	    lappend retNodes $domNode
	}       
	list_entities_no_group {
	    lassign [lrange $args 0 1] domNodes geom_mesh
	    lassign [gid_groups_conds::list_entities_give_data_no_group_full $domNodes $geom_mesh] columnList cndList rows                          

	    set domNode [$ndoc createElement table]
	    $domNode setAttribute tabstyle spreadsheet 
	    
	    set rNode [$domNode appendChildTag row]
	    foreach col $columnList {
		$rNode appendChildTag entry emphasis [list attributes() \
		        role strong] [list text() $col]
	    }
	    foreach row $rows {
		set rNode [$domNode appendChildTag row]
		foreach col $row {
		    $rNode appendChildTag entry [list text() $col]
		}
	    }                       
	    
	    set udNode [$domNode appendChildTag user_defined [list attributes() n0 gidr \
		        comment $comment n list_entities page_id $page_id]]
		      
	    _list_entities_from_data_to_xml $domNodes $geom_mesh $udNode
	    lappend retNodes $domNode
	}
    }
    return $retNodes
}

proc gid_groups_conds::create_report_part_xml { main_node_name part_name page_id args } {
    
    dom createDocument $main_node_name ndoc
    set root [$ndoc documentElement]

    foreach domNode [create_report_part $ndoc $part_name $page_id {*}$args] {
	$root appendChild $domNode
    }
    return [$root asXML -indent none]
}

proc gid_groups_conds::update_report_full_page { xml } {

    variable doc

    set root [$doc documentElement]
    dom parse $xml ndoc

    set xp {/*/user_defined[@n='page']}
    set udNode [$ndoc selectNodes $xp]
    
    if { $udNode eq "" } { return [update_report_page $xml] }
    
    set nroot [$ndoc documentElement]
    set xp [$udNode @xpath]
    set page_id [$udNode @page_id]
    foreach i [$nroot childNodes] { $i delete }
    
    set domNode [$root selectNodes $xp]
    _create_report_page $domNode $nroot $page_id
    return [$ndoc asXML -indent none]
}

proc gid_groups_conds::update_report_pageList { pageList } {
    variable is_draw_post
    
    set page_docList ""
    set udNodeList ""
    foreach i $pageList {
	foreach "name data" $i break
	set ndoc [dom parse $data]
	lappend page_docList [list $name $ndoc]
	set num 0
	foreach udNode [$ndoc selectNodes //user_defined] {
	    if { [$udNode selectNodes {@n='current_view'}] } {
		if { [$udNode selectNodes {prepost='GEOMETRYUSE' or prepost='MESHUSE'}] } {
		    set prepost pre
		} else {
		    set prepost post
		}
	    } else {
		set prepost ""
	    }
	    lappend udNodeList [list $prepost $udNode]
	}
    }
    unset pageList
    
    if { [llength $udNodeList] } {
	set state [_get_view_state]
	if { !$is_draw_post } {
	    set ViewMode [GiD_Info Project ViewMode]
	    if { [lsearch -exact [list GEOMETRYUSE MESHUSE] $ViewMode] != -1 } {
		set inc -decreasing
	    } else {
		set inc -increasing
	    }
	    set udNodeList [lsort -index 0 $inc $udNodeList]
	}
	foreach i $udNodeList {
	    set udNode [lindex $i 1]
	    update_report_user_defined_node $udNode
	}
	_set_view_state $state
    }
    set ret ""
    foreach i $page_docList {
	foreach "name ndoc" $i break
	lappend ret [list $name [$ndoc asXML -indent none]]
	$ndoc delete
    }
    return $ret
}

proc gid_groups_conds::update_report_page { xml } {
    variable doc

    set root [$doc documentElement]
    dom parse $xml ndoc

    set state [_get_view_state]
    foreach udNode [$ndoc selectNodes //user_defined] {
	update_report_user_defined_node $udNode
    }
    _set_view_state $state
    return [$ndoc asXML -indent none]
}

proc gid_groups_conds::update_report_user_defined_node { udNode } {
    variable doc

    set root [$doc documentElement]
    set domNode [$udNode parentNode]
    set newNodes ""
    set page_id [$udNode @page_id ""]
    set ndoc [$udNode ownerDocument]
    switch [$udNode @n] {
	first_page {
	    set ret [create_report_part $ndoc [$udNode @n] $page_id]
	    lappend newNodes {*}$ret
	}
	container_table - condition_table {
	    set xp [$udNode @xpath]
	    foreach n [$root selectNodes $xp] {
		set ret [create_report_part $ndoc [$udNode @n] $page_id $n]
		lappend newNodes {*}$ret
	    }
	}
	current_view {
	    set d ""
	    foreach n [$udNode childNodes] {
		dict set d [$n nodeName] [$n text]
	    }
	    set ret [create_report_part $ndoc [$udNode @n] $page_id $d]
	    lappend newNodes {*}$ret
	}
	reports_post {
	    set d [_reports_post_win_from_xml_to_dict $udNode]
	    set ret [create_report_part $ndoc [$udNode @n] $page_id $d]
	    lappend newNodes {*}$ret
	}
	list_entities {
	    foreach "domNodes geom_mesh" [_list_entities_from_xml_to_data $udNode] break
	    set ret [create_report_part $ndoc [$udNode @n] $page_id $domNodes $geom_mesh]
	    lappend newNodes {*}$ret
	}
    }
    if { [llength $newNodes] } {
	set parentNode [$domNode parentNode]
	foreach newNode $newNodes {
	    $parentNode insertBefore $newNode $domNode
	}
	$domNode delete
    }
}

proc gid_groups_conds::_create_report_page { args } {
    
    set optional {
	{ -noprintList list "" }
    }
    set compulsory "domNode sNode page_id"
    parse_args $optional $compulsory $args
    
    set ndoc [$sNode ownerDocument]
    set xp ""
    append xp {container[value]|container/container[value]|blockdata[value]}
    append xp {|container[edit_command[@proc_print_xml]]|container/container[edit_command[@proc_print_xml]]}
    append xp {|blockdata/container[value]|blockdata/container/container[value]}
    append xp {|container/blockdata/container[value]}
    set isfound 0
	
    foreach cNode [$domNode selectNodes $xp] {
	set isfound 1
	set hidden 0
	set n $cNode
	while { $n ne "" } {
	    if { [get_domnode_attribute $n state normal] eq "hidden" } {
		set hidden 1
		break
	    }
	    if { [get_domnode_attribute $n active 1] == 0 } {
		set hidden 1
		break
	    }
	    set n [$n parentNode]
	}
	if { $hidden } { continue }
	
	set found 0
	foreach aNode [$cNode selectNodes ancestor-or-self::*] {
	    if { [get_domnode_attribute $aNode n ""] in $noprintList } {
		set found 1
		break
	    }
	}
	if { $found } { continue }
	
	if { [$cNode parentNode] eq $domNode } {
	    set title [get_domnode_attribute $cNode pn]
	} 
	if {[get_domnode_attribute [$cNode parentNode] name] ne ""} {
	    set title "[get_domnode_attribute [$cNode parentNode] name]"
	    append title "[get_domnode_attribute [$cNode parentNode] pn]"
	} else {
	    set title "[get_domnode_attribute [$cNode parentNode] pn]"
	}
	if {[get_domnode_attribute $cNode name] ne ""} {
	    append title " - [get_domnode_attribute $cNode name]"
	} else {
	    append title " - [get_domnode_attribute $cNode pn]"
	}
	
	$sNode appendXML "<para><emphasis role='header'
	    >[xml_map $title]</emphasis></para>"
	foreach node [create_report_part $ndoc container_table $page_id $cNode] {
	    $sNode appendChild $node
	}
    }
    foreach cndNode [$domNode selectNode {condition[group]|container/condition[group]}] {
	if { [get_domnode_attribute $sNode state normal] eq "hidden" } { continue }
	if { [get_domnode_attribute $sNode active 1] == 0 } { continue }
	if { [get_domnode_attribute $sNode n ""] in $noprintList } { continue }
	set isfound 1
	
	set title "[get_domnode_attribute $cndNode pn]"
	$sNode appendXML "<para><emphasis role='header'
	    >[xml_map $title]</emphasis></para>"
	foreach node [create_report_part $ndoc condition_table $page_id $cndNode] {
	    $sNode appendChild $node
	}
	      
	foreach grNode [$cndNode selectNodes group] {
	    set functList "" 
	    foreach vNode [$grNode selectNodes .//value] {
		set state [get_domnode_attribute $vNode state]                                                  
		if {$state eq "hidden"} { continue }
		set parentNode [$vNode parentNode]
		if {[$parentNode nodeName] != "functionVariable"} { 
		    set nv [$vNode @pn]
		    continue 
		}                                                                                                               
		set v [gid_groups_conds::give_printable_value $vNode]
		if {[regexp (.*),(.*) $v {} xfun yfun]} {               
		    lappend functList $nv $xfun $yfun
		}
	    }                          
	    if {$functList != ""} { 
#                 $sNode appendXML "<para>[$grNode @n]</para>"    
#                 $sNode appendXML [create_graph_function $functList $grNode]                    
	    }
	}            
    }
    foreach bNode [$domNode selectNodes {.//blockdata[@sequence="1"]}] {
	set isfound 1
	set is_compressed [uncompress_subtree $bNode]
	foreach cndNode [$bNode selectNodes {.//condition[group]}] {
	    if { [get_domnode_attribute $cndNode state normal] eq "hidden" } { continue }
	    if { [get_domnode_attribute $cndNode active 1] == 0 } { continue }
	    
	    set title "[= Loadcase] [get_domnode_attribute $bNode name]"
	    append title " - [get_domnode_attribute $cndNode pn]"
	    $sNode appendXML "<para><emphasis role='header'
		>[xml_map $title]</emphasis></para>"
	    foreach node [create_report_part $ndoc condition_table $page_id $cndNode] {
		$sNode appendChild $node
	    }
	}
	if { $is_compressed } { compress_subtree $bNode }
    }
    
    if { !$isfound && [get_domnode_attribute $domNode state normal] ne "hidden" } { 
	switch [$domNode nodeName] {
	    blockdata {              
		if {[$domNode @name ""] ne ""} {
		    set title "[get_domnode_attribute $domNode name]"
		} else {
		    set title "[get_domnode_attribute $domNode pn]"
		}              
		$sNode appendXML "<para><emphasis role='header'
		    >[xml_map $title]</emphasis></para>"
		foreach node [create_report_part $ndoc container_table $page_id $domNode] {
		    $sNode appendChild $node
		}
	    }   
	    container {                             
		set title "[get_domnode_attribute $domNode pn]"                
		$sNode appendXML "<para><emphasis role='header'
		    >[xml_map $title]</emphasis></para>"
		foreach node [create_report_part $ndoc container_table $page_id $domNode] {
		    $sNode appendChild $node
		}
	    }         
	}                
    }

    set date [clock format [clock seconds] -format "%Y-%m-%d"]
    set comment [_ "Created automatically at %s" $date]

    $sNode appendChildTag user_defined [list attributes() n0 gidr \
	    comment $comment n page page_id $page_id \
	    xpath [gid_groups_conds::nice_xpath $domNode]]
}

# proc gid_groups_conds::create_graph_function { functList groupNode } {
#     set xyvalues ""
#     foreach "nv xfun yfun" $functList {
#         lappend xyvalues "$xfun $yfun"        
#     }
#     set win .funct000
#     catch { destroy $win }
#     set win [cu::draw_graphs $win -xyvalues [list $xyvalues] \
#             -xlabel x -ylabel f -title [$groupNode @n] -xlabelunit "s" \
#             -ylabelunit "N"]       
#     set svg [$win svg]  
#    
#     return $svg
# }

proc gid_groups_conds::create_report_xml {} {
    variable doc      

    set root [$doc documentElement]
    set ndoc [dom parse <lognoter/>]
    set resNode [$ndoc documentElement]

    set pagesList ""

    set sNode [$resNode appendChildTag section]
    $sNode appendChildTag title [list text() [_ "Report"]]

    foreach node [create_report_part $ndoc first_page ""] {
	$sNode appendChild $node
    }

    foreach domNode [$doc selectNodes /*/blockdata|/*/container] {
	if { [get_domnode_attribute $domNode state normal] eq "hidden" } { continue }
	if { [get_domnode_attribute $domNode active 1] == 0 } { continue }

	set sNode [$resNode appendChildTag section]
	set pn [get_domnode_attribute $domNode pn]
	set title "[= Report]>$pn"
	$sNode appendChildTag title [list text() $title]
	lappend pagesList $pn

	_create_report_page $domNode $sNode $title
    }

    set sNode [$resNode appendChildTag section [list attributes() \
		page_type TOC]]
    $sNode appendChildTag title [list text() [_ "table of contents"]]

    $sNode appendChildTag itemizedlist listitem ulink \
	[list attributes() url "[= Report]" linktype local] \
	[list text() [= Report]]
    foreach page $pagesList {
	$sNode appendChildTag itemizedlist listitem blockquote ulink \
	    [list attributes() url "[= Report]>$page" linktype local] \
	    [list text() $page]
    }

#     set page [_ "table of contents"]
#     $sNode appendChildTag itemizedlist listitem ulink \
#             [list attributes() url $page linktype local] \
#             [list text() $page]


    set tempfile [cu::file::tempfile lognoter]
    file rename -force $tempfile $tempfile.xml
    set xmlfile $tempfile.xml

    set fout [open $xmlfile w]
    fconfigure $fout -encoding utf-8
    puts $fout {<?xml version="1.0" encoding="utf-8"?>}
    puts $fout {<!DOCTYPE lognoter>}
    puts $fout [$ndoc asXML -indent none]
    close $fout

    return $xmlfile
}

proc gid_groups_conds::_give_report_filename { default_file } {
    
    set model_name [gid_groups_conds::give_model_name]

    set s_lognoter_file [internal_data get lognoter_file]
    if { $s_lognoter_file ne "" && [file exists $s_lognoter_file] } {
	return $s_lognoter_file
    }
    
    if { $default_file eq "" } { return "" }
    
    if { $model_name eq "UNNAMED" } {
	set lognoter_file [cu::file::tempfile ggc].wnl
	file delete -force $lognoter_file
    } else {
	set lognoter_file [file join $model_name.gid [file tail $model_name.wnl]]
	file delete -force $lognoter_file
    }
    if { ![file exists $lognoter_file] } {
	file copy $default_file $lognoter_file
    }
    set lognoter_file [file normalize $lognoter_file]
    internal_data set lognoter_file $lognoter_file

    return $lognoter_file
}

proc gid_groups_conds::add_automatic_pages_to_report { args } {
    variable doc
    variable add_report

    set optional {
	{ -open_lognoter boolean 1 }
	{ -default_copy_file name "" }                
	{ -deiconify_win boolean 1 }        
	{ -parent_window window "" }
	{ -open_xlsx boolean 0 }        
    }
    set compulsory ""
    parse_args $optional $compulsory $args
    
    set lognoter_file [_give_report_filename ""]

    if {$lognoter_file ne "" } {
	set txt [_ "Some pages in the report may be modified or updated. Proceed?"]
	set ret [snit_messageBox -type okcancel -default ok -message $txt -parent $parent_window]
	if { $ret == "cancel" } { return "" }
    }

    set xmlfile [$add_report]
    set cmd "import_from_file -file [list $xmlfile] -noconfirm -delete_file_after;"
    append cmd "showpage_type Home;"
    append cmd "toctree_add -force_open;"
    append cmd "[list toctree_process expand_page [_ "Report"]];"
       
    if { $open_lognoter } {
	view_report -execute_commands $cmd -default_copy_file $default_copy_file \
	    -check_if_new 0 -deiconify_win $deiconify_win -open_xlsx $open_xlsx             
    }
    return $cmd
}

proc gid_groups_conds::delete_report { args } {
    set optional {
	{ -default_copy_file name "" }
	{ -parent_window window "" }
    }
    set compulsory ""
    parse_args $optional $compulsory $args
    
    set lognoter_file [_give_report_filename ""]

    if {$lognoter_file ne "" } {
	set txt [_ "Are you sure to delete existing report?"]
	set ret [snit_messageBox -parent $parent_window -type okcancel -default ok \
		-message $txt]
	if { $ret == "cancel" } { return }
    } else {
	set txt [_ "There is no report to delete"]
	set ret [snit_messageBox -parent $parent_window -message $txt]
	return
    }
    
    close_report_help_window report
    set err [catch { file delete -force $lognoter_file } errstring]
    if { !$err } {
	gid_groups_conds::internal_data delete lognoter_file
    }
    
}

proc gid_groups_conds::add_current_view_to_report { args } {

    set optional {
	{ -default_copy_file name "" }
	{ -deiconify_win boolean 1 }
    }
    set compulsory ""
    parse_args $optional $compulsory $args

    set data [gid_groups_conds::create_report_part_xml lognoter current_view \
	    [_ "Images"]]

    set cmd [list createpage -ask_user -goto -accept_existing_pages \
	    [= Report]>[_ "Images"] - $data ""]
    
    set err [catch { view_report -raise_error -default_copy_file $default_copy_file \
		-execute_commands_after $cmd -deiconify_win $deiconify_win } errstring]
    if { $err } {
	snit_messageBox -message $errstring
	return
    }        
}

namespace eval gid_groups_conds {
    variable flognoter ""
    variable lognoter_tclinterp ""
    
    variable help_flognoter ""
    variable help_lognoter_tclinterp ""
    
}

proc gid_groups_conds::_report_data_from_lognoter { fin } {
    variable data_from_lognoter_buf
    variable flognoter
    variable help_flognoter
    
    if { [eof $fin] } {
	catch { close $fin }
	if { $fin eq $flognoter } {
	    set flognoter ""
	} else {
	    set help_flognoter ""
	}
	return
    }
    if { ![info exists data_from_lognoter_buf($fin)] } {
	set data_from_lognoter_buf($fin) ""
    }
    set line [gets $fin]
    if { $line eq "" } { return }
    append data_from_lognoter_buf($fin) "$line\n"
    if { [info complete $data_from_lognoter_buf($fin)] } {
	set ret [eval $data_from_lognoter_buf($fin)]
	puts $fin [list $ret]
	flush $fin
	set data_from_lognoter_buf($fin) ""
    }
}

proc gid_groups_conds::_report_data_from_lognoter_cmd { args } {
    return [eval $args]
}

proc gid_groups_conds::close_report_help_window { args } {
    variable flognoter
    variable lognoter_tclinterp
    variable help_flognoter
    variable help_lognoter_tclinterp

    set optional {
	{ -destroy_window w "" }
    }
    set compulsory "what"
    parse_args $optional $compulsory $args
	
    set top [gid_groups_conds::give_toplevel]
    if { $destroy_window ne "" && $destroy_window ne $top } { return }

    switch $what {
	report {
	    upvar 0 flognoter flog
	    upvar 0 lognoter_tclinterp intp
	}
	help_viewer {
	    upvar 0 help_flognoter flog
	    upvar 0 help_lognoter_tclinterp intp
	}
	all {
	    close_report_help_window report
	    close_report_help_window help_viewer
	    return
	}
    }
    if { $flog ne "" } {
	package require customLib_utils
	package require customLib_utils::c
	cu::kill [pid $flog]
	catch { close $flog }
	set flog ""
    } elseif {$intp ne "" } {
	lassign $intp inp r
	if { ![interp exists $inp] || [$inp eval [list info command $r]] eq "" } {
	    set intp ""
	    return
	}
	$inp eval [list $r configure -hide_on_exit 0]
	$inp eval [list $r process quit]
#         interp delete lognoter
#         package forget Lognoter
	set intp ""
    }
}

proc gid_groups_conds::raise_if_open_report_help_window { what execute_commandsList } {
    variable flognoter
    variable lognoter_tclinterp
    variable help_flognoter
    variable help_lognoter_tclinterp

    switch $what {
	report {
	    upvar 0 flognoter flog
	    upvar 0 lognoter_tclinterp intp
	}
	help_viewer {
	    upvar 0 help_flognoter flog
	    upvar 0 help_lognoter_tclinterp intp
	}
    }
    if {![info exists flo] || ![info exists intp]} {
	return 0
    }
    if { $flog ne "" } {
	lappend execute_commandsList raise_main_window
	foreach i $execute_commandsList {
	    puts $flog $i
	    flush $flog
	}
	return 1
    } elseif { $intp ne "" } {
	lassign $intp inp r
	if { ![interp exists $inp] || [$inp eval [list info command $r]] eq "" } {
	    set intp ""
	    return 0
	}
	lappend execute_commandsList raise_main_window
	foreach i $execute_commandsList {
	    interp eval $inp [list $r give_evaltclinterp $i]
	}
	return 1
    }
    return 0
    
}

proc gid_groups_conds::report_check_name { filespd } {
    
    set lognoter_file [file normalize [file root $filespd].wnl]
    set s_lognoter_file [internal_data get lognoter_file]
    if { $s_lognoter_file ne "" && $lognoter_file ne $s_lognoter_file } {
	close_report_help_window report
	catch {file copy -force $s_lognoter_file $lognoter_file }
	if { [file exists $lognoter_file] } {
	    internal_data set lognoter_file $lognoter_file
	} else {
	    internal_data set lognoter_file ""
	}
    }
}

proc gid_groups_conds::report_set_default_copy_file { file } {
    variable report_default_copy_file
    
    set report_default_copy_file $file
}

proc gid_groups_conds::report_clear_default_copy_file {} {
    variable report_default_copy_file

    unset -nocomplain report_default_copy_file
}

proc gid_groups_conds::report_can_add {} {
    variable report_default_copy_file

    return [info exists report_default_copy_file]
}

proc gid_groups_conds::view_report { args } {
    variable flognoter
    variable lognoter_tclinterp
    variable report_default_copy_file     
    variable add_report     
    
    set optional {
	{ -execute_commands script "" }
	{ -execute_commands_after script "" }
	{ -default_copy_file name "" }
	{ -raise_error "" 0 }
	{ -check_if_new boolean 1 }
	{ -parent_window window "" }        
	{ -add_report name create_report_xml }   
	{ -create_always_report boolean 0 }    
	{ -deiconify_win boolean 1 }
	{ -open_xlsx boolean 0 }
	{ -add_progress_bar w "" }       
    }
    set compulsory ""
    parse_args $optional $compulsory $args       
    
    if { $default_copy_file eq "" } {
	set default_copy_file $report_default_copy_file
    }
   
    if { $parent_window eq "" } {
	set parent_window [gid_groups_conds::give_toplevel]
    }
    set lognoter_file [_give_report_filename ""]    
    if { $add_progress_bar != "" && $open_xlsx } {
	catch { destroy $add_progress_bar.bar }
	set pbar [ttk::progressbar $add_progress_bar.bar -orient horizontal \
		-mode indeterminate -length 100]    
    }
	
    if { ($check_if_new && $lognoter_file eq "") || $create_always_report} {       
	set values [list [_ "Add default report pages"] [_ "Do not add. Only for notes"]]        
	set view_report_add_default [get_preference view_report_add_default add]
	switch $view_report_add_default {
	    add { set default [lindex $values 0] }
	    noadd { set default [lindex $values 1] }
	}    
	if { $create_always_report } {
	    set value [lindex $values 0]
	} else {
	    set text [_ "Report does not exist and it will be created. What do you want to do?"]:
	    set w [dialogwin_snit $parent_window._ask -title [_ "Open report"] -entrytype noneditable_entry \
		    -entrytext $text -entryvalues $values -entrydefault $default -grab 1 -transient 1]
	    ###            
	    ###
	    set action [$w createwindow]
	  
	    set value [$w giveentryvalue]
	    destroy $w
	    if { $action <= 0 } {               
		return             
	    }        
	} 
	if { $add_progress_bar != "" && $open_xlsx } {           
	    .gid configure -cursor "watch"
	    grid $pbar -row 0 -column 12 -padx "5 2" -pady "0 2" -sticky "e" 
	    $pbar start                       
	}

	if { $value eq [lindex $values 0] } {
	    set view_report_add_default add
	    set err [catch { add_automatic_pages_to_report -open_lognoter 0 \
		        -default_copy_file $default_copy_file } cmd]
	    if { $err } {
		snit_messageBox -message $cmd
		if { $add_progress_bar != "" && [info exists pbar] != "" } { 
		    $pbar stop 
		    destroy $pbar
		}
		return
	    }
	    set execute_commands "$cmd; $execute_commands"
	} else {
	    set view_report_add_default noadd
	}
	set_preference view_report_add_default $view_report_add_default
    }

    set lognoter_file [_give_report_filename $default_copy_file]  
    
    if {$lognoter_file eq "" } {
	if { $add_progress_bar != "" && [info exists pbar] } { 
	    $pbar stop            
	    destroy $pbar
	}
	if { $raise_error } {
	    error [_ "Error: Could not create report"]
	}
	return
    }
    if {!$create_always_report} {
	set ret [raise_if_open_report_help_window report [list $execute_commands \
		    $execute_commands_after]]
	if { $ret } { 
	    if { $add_progress_bar != "" && [info exists pbar] } { 
		$pbar stop 
		destroy $pbar
	    }
	    return 
	}
    }   
    set nv [list \
	    [list [_ "Image from RamSeries"] [list ramseries::image_from_GiD]] \
	    [list [_ "Update page"] [list ramseries::update_page 0]] \
	    [list [_ "Update page (full)"] [list ramseries::update_page 1]] \
	    [list --- {}] \
	    [list [_ "Update all pages"] [list ramseries::update_all_pages]] \
	    ]
    append execute_commands "; [list add_custom_menu [= Reports] $nv]"
    
    set lan [gid_groups_conds::GetCurrentLanguage]

    set argv [list \
	    -manageicontray 0 -prefs_data \
	    [list geometry_default {{} 950x550 {tree 200}}] \
	    -hide_on_exit 1 -execute_commands $execute_commands \
	    -title [_ "Reports"] -saveprefs only_in_group \
	    -dbtype sqlite -notebookname $lognoter_file \
	    -deiconify_win $deiconify_win]    
    
    if { ![interp exists lognoter_intp] } {
	interp create lognoter_intp
	lognoter_intp eval [list set argv [list -language $lan]]
    }
    set cmd [list gid_groups_conds::close_report_help_window -destroy_window %W report]
    bind [gid_groups_conds::give_toplevel] <Destroy> "+$cmd"
    
    set err [catch { package require Lognoter }]
    
    set prefer_lognoter_exe 0
    
    if { !$prefer_lognoter_exe && !$err } {
	interp alias lognoter_intp exit "" return
	lappend argv -external_master_callback eval_master
    
	lognoter_intp eval lappend auto_path $::auto_path
	# necessary to avoid loading different versions in main interp and slave interp
	lognoter_intp eval [list package require -exact treectrl [package require treectrl]]

	set r [lognoter_intp eval lognoter .%AUTO% $argv]
	set lognoter_tclinterp [list lognoter_intp $r]
	interp alias lognoter_intp eval_master "" gid_groups_conds::_report_data_from_lognoter_cmd
		
	if { !$deiconify_win } {                         
	    set values [dict create ewhatout TOC tofile 0 default_image_size 90 \
		    default_image_size_active 0 all_languages 0 printer_margins 0.0 crop_marks 0 \
		    TableDrawLines 0 eformat xlsx template default \
		    template_type directory notebookname $lognoter_file \
		    current_values {} dbtype sqlite]
	    
	    set lognoter_db [lognoter_intp eval lognoter_db %AUTO%]
	    if { $open_xlsx } {                
		set t [lognoter_intp eval $lognoter_db open -filetable $lognoter_file]               
		set s [lognoter_intp eval $lognoter_db exporttofile [list $values]]    
		lognoter_intp eval $lognoter_db close  
		.gid configure -cursor "arrow"              
	    }
	}        
    } else {
	close_report_help_window report

	set lognoter_exe [give_lognoter_exe]
	set cmd [list $lognoter_exe {*}$argv]
	
	set flognoter [open |$cmd w+]
	fconfigure $flognoter -blocking 0 -encoding utf-8
	fileevent $flognoter readable [list \
		gid_groups_conds::_report_data_from_lognoter $flognoter]
    }
	    
    if { $execute_commands_after ne "" } {
	raise_if_open_report_help_window report [list $execute_commands_after]
    }
       
    if { $add_progress_bar != "" && [info exists pbar] } { 
	$pbar stop         
	destroy $pbar
    }
 
#     set path ""
#     set cmd ""
#     foreach i [list HKEY_CURRENT_USER HKEY_LOCAL_MACHINE] {
#         set err [catch {
#                 set v [registry get "$i\\Software\\Compass\\Lognoter" CurrentVersion]
#                 set path [registry get "$i\\Software\\Compass\\$v" InstallPath]
#             }]
#         if { !$err } { break }
#     }
#     if { $path ne "" } {
#         set cmd0 [file join $path Lognoter.exe]
#         set cmd [list $cmd0]
#     }
#     
#     if { $cmd eq "" } {
#         snit_messageBox -message [_ "It is necessary to have the program Lognoter installed"]
#         return
#     }

}

# proc gid_groups_conds::raise_if_open_help_viewer { execute_commandsList } {
#     variable help_lognoter_tclinterp
#     
#     if { [info exists help_lognoter_tclinterp] && $help_lognoter_tclinterp ne "" } {
#         if { ![interp exists $help_lognoter_tclinterp] } {
#             set help_lognoter_tclinterp ""
#             return 0
#         }
#         foreach "inp r" $help_lognoter_tclinterp break
#         lappend execute_commandsList raise_main_window
#         foreach i $execute_commandsList {
#             interp eval $inp [list $r give_evaltclinterp $i]
#         }
#         return 1
#     }
#     return 
# }

proc gid_groups_conds::give_lognoter_exe {} {
    variable problemtype_lib_dir
    
    set lognoter_exe ""
    if { [info exists problemtype_lib_dir] } {
	set lognoter_exe [file join $problemtype_lib_dir lognoter Lognoter.exe]
	if { [auto_execok $lognoter_exe] eq "" } { set lognoter_exe "" }
    }
    if { $lognoter_exe eq "" } {
	set lognoter_exe [file join $::GIDDEFAULT problemtypes common_lib lognoter Lognoter.exe]
	if { [auto_execok $lognoter_exe] eq "" } { set lognoter_exe "" }
    }    
    return $lognoter_exe
}

proc gid_groups_conds::open_help_viewer { args } {
    variable help_flognoter
    variable help_lognoter_tclinterp

    set optional {
        { -open_page page_name "" }
        { -select_in_tree name "" }
        { -key key "" }
        { -lognoter_exe exe_file "" }
    }
    set compulsory "dbfile"
    parse_args $optional $compulsory $args

    if { $open_page ne "" } {
        set execute_commands0 [list openlognoter_in -key $key -page $open_page $dbfile]
    } else {
        set execute_commands0 [list openlognoter_in -key $key -page_type Home $dbfile]
    }
    set execute_commands ""
    if { $open_page ne "" } {
        append execute_commands ";[list showpage $open_page]"
    }
    if { $select_in_tree ne "" } {
        append execute_commands ";[list toctree_process expand_page $select_in_tree]"
        append execute_commands ";[list toctree_process select_in_tree [list $select_in_tree]]"
    }
    set ret [raise_if_open_report_help_window help_viewer [list $execute_commands0 $execute_commands]]
    if { $ret } { return }

    package require customLib

    set lan [gid_groups_conds::GetCurrentLanguage]
    #if { $lan ne "es" } { set lan "" }

    set argv [list -readprefs 0 -readonly 1 -language $lan \
        -manageicontray 0 -prefs_data \
        [list view_languages_toolbar 0 add_more_pages_to_tree 0 \
        view_main_menu 0 geometry_default {{} 940x700 {tree 200}}] \
        -hide_on_exit 1 -execute_commands $execute_commands \
        -title [_ "Help viewer"] -saveprefs only_in_group \
        -dbtype sqlite -notebookname $dbfile -key $key]

    if { ![interp exists lognoter_intp] } {
        interp create lognoter_intp
        lognoter_intp eval lappend auto_path $::auto_path
        #lognoter_intp eval [list set auto_path $::auto_path]
        lognoter_intp eval [list set argv [list -language $lan]]
    }
    set cmd [list gid_groups_conds::close_report_help_window -destroy_window %W help_viewer]
    bind [gid_groups_conds::give_toplevel] <Destroy> "+$cmd"

    set prefer_lognoter_exe "lognoter_package"

    if { $lognoter_exe eq "" } {
        set lognoter_exe [give_lognoter_exe]
    }
    if { $lognoter_exe eq "" && \
        [file exists [file join $::GIDDEFAULT scripts compass Lognoter Lognoter.vfs main.tcl]] } {
        set prefer_lognoter_exe "lognoter_vfs"
    } elseif { $lognoter_exe ne "" } {
        set prefer_lognoter_exe "lognoter_exe"
    }
    if { $prefer_lognoter_exe eq "lognoter_package" } {
        set err [catch { package require Lognoter } errstring]
        if { $err } {
            set prefer_lognoter_exe "lognoter_exe"
        }
    }
    if { $prefer_lognoter_exe eq "lognoter_package"} {
        interp alias lognoter_intp exit "" return
        lappend argv -external_master_callback eval_master

        # necessary to avoid loading different versions in main interp and slave interp
        lognoter_intp eval [list package require -exact treectrl [package require treectrl]]

        set r [lognoter_intp eval lognoter .%AUTO% $argv]
        set help_lognoter_tclinterp [list lognoter $r]
        interp alias lognoter_intp eval_master "" gid_groups_conds::_report_data_from_lognoter_cmd
    } elseif { $prefer_lognoter_exe eq "lognoter_exe"} {
        close_report_help_window help_viewer

        if { $lognoter_exe eq "" } {
            set lognoter_exe [give_lognoter_exe]
            if { $lognoter_exe eq "" } {
                GID_tk_messageBox -message "Could not find lognoter executable" {*}[ GidUtils::GiDDefaultParentIfPresent]
            }
        }
        set cmd [list $lognoter_exe {*}$argv]

        set help_flognoter [open |$cmd w+]
        fconfigure $help_flognoter -blocking 0 -encoding utf-8
        fileevent $help_flognoter readable [list \
            gid_groups_conds::_report_data_from_lognoter $help_flognoter]
        after 100 [list gid_groups_conds::raise_if_open_report_help_window help_viewer \
            [list $execute_commands0 $execute_commands]]
    } elseif { $prefer_lognoter_exe eq "lognoter_vfs" } {
        interp alias lognoter_intp exit "" return

        # necessary to avoid loading different versions in main interp and slave interp
        lognoter_intp eval [list package require -exact treectrl [package require treectrl]]
        lognoter_intp eval [list package forget app-lognoter]
        set vfs_lib_folder [file join $::GIDDEFAULT scripts compass Lognoter Lognoter.vfs lib]
        if { [lsearch $::auto_path $vfs_lib_folder] == "-1" } {
            lappend ::auto_path $vfs_lib_folder
        }
        lognoter_intp eval [list set auto_path $::auto_path]

        set source_file [file join $::GIDDEFAULT scripts compass Lognoter Lognoter.vfs main.tcl]

        # To source a file and pass arguments to the script (the source command only accepts a filename)
        lognoter_intp eval [list set argv0 [set ::argv0]]
        lognoter_intp eval [list set argv $argv]
        lognoter_intp eval [list source $source_file]
    }
}

proc check_gid_help {} {
    
    if { [file exists [file join $::GIDDEFAULT manuals gid_reference_manual.wnl]] } {
	package require customLib
	auto_load GiDHelpWindow
	rename GiDHelpWindow GiDHelpWindow_base
	
	proc GiDHelpWindow { args } {
	    set ipos [lsearch -exact $args -start]
	    set what [lindex $args [incr ipos]]
	    
	    switch $what {
		html-version { set name gid_reference_manual }
		html-customization { set name gid_customization }
		html_whatsnew { set name gid_what_s_new }
		html-faq { set name gid_FAQ }
		default {
		    return [GiDHelpWindow_base {*}$args]
		}
	    }
	    set dbfile [file join $::GIDDEFAULT manuals $name.wnl]
	    gid_groups_conds::open_help_viewer -key compass99 $dbfile
	}
    }
    GiDMenu::RemoveOption Help Tutorials PREPOST
    GiDMenu::UpdateMenus
}

################################################################################
#    Reports Post
################################################################################

proc gid_groups_conds::reports_post_win { wp } {
    variable doc
    
    destroy $wp._ask
    set w [dialogwin_snit $wp._ask -title [_ "List postprocess entities"] \
	    -callback [list gid_groups_conds::reports_post_win_do] \
	    -transient 1]
    set f [$w giveframe]
    
    set f1 [ttk::labelframe $f.f1 -text [_ "results"]]
    
    ttk::radiobutton $f1.r1 -text [_ "Current loadcase"] -variable [$w give_uservar what_loadcase] \
	-value current
    ttk::radiobutton $f1.r2 -text [_ "All loadcases"] -variable [$w give_uservar what_loadcase] \
	-value all
    
    ttk::radiobutton $f1.r3 -image [gid_themes::GetImage node medium_icons] -style Toolbutton \
	-variable [$w give_uservar enposttype] -value Nodes
    ttk::radiobutton $f1.r4 -image [gid_themes::GetImage element medium_icons] -style Toolbutton \
	-variable [$w give_uservar enposttype] -value Elements
    ttk::radiobutton $f1.r5 -text [= All] -style Toolbutton \
	-variable [$w give_uservar enposttype] -value All

    cu::check_listbox $f1.cb1 -width 200 -height 140 -bd 1 -relief solid
    $w set_uservar_value res_listbox $f1.cb1
    
    grid $f1.r1 $f1.r2 $f1.r3 $f1.r4 $f1.r5 -sticky w -padx 4 -pady 2
    grid $f1.cb1   -  - - - -sticky news -padx 4 -pady "2 5"
    
    grid configure $f1.r3 $f1.r4 $f1.r5 -sticky w -padx 0 -pady 2
    
    grid columnconfigure $f1 1 -weight 1
    grid rowconfigure $f1 1 -weight 1

    set f2 [ttk::labelframe $f.f2 -text [_ "gauss points"]]

    ttk::label $f2.l1 -text [_ "When one element has several Gauss Points with results. Output:"] \
	-wraplength 170 -justify left
    
    ttk::radiobutton $f2.r1 -text [_ "All values"] -variable [$w give_uservar gauss] \
	-value all
    ttk::radiobutton $f2.r2 -text [_ "Maximum values"] -variable [$w give_uservar gauss] \
	-value maxabs
    ttk::radiobutton $f2.r3 -text [_ "Maximum & minimum values"] -variable [$w give_uservar gauss] \
	-value max

    grid $f2.l1 -sticky w -padx 4 -pady 2
    grid $f2.r1 -sticky w -padx 4 -pady 2
    grid $f2.r2 -sticky w -padx 4 -pady 2
    grid $f2.r3 -sticky nw -padx 4 -pady 2

    grid columnconfigure $f2 1 -weight 1
    grid rowconfigure $f2 3 -weight 1
  
    set f3 [ttk::labelframe $f.f3 -text [_ "include entities"]]
    
    ttk::radiobutton $f3.r1 -text [_ "All entities"] -variable [$w give_uservar entities] \
	-value all
    ttk::radiobutton $f3.r2 -text [_ "Selected entities"] -variable [$w give_uservar entities] \
	-value sel
    ttk::radiobutton $f3.r3 -text [_ "Groups"] -variable [$w give_uservar entities] \
	-value groups
    
    ttk::checkbutton $f3.cb3 -text [_ "Only entities with data"] -variable \
	[$w give_uservar onlywithdata]

    set cmd [list gid_groups_conds::_reports_post_win_select_entities $w $f3.b1]
    cu::menubutton_button $f3.b1 -text [_ "Select in screen (%d)" 0]... \
	-menu $f3.b1.m -command "$cmd same"
    menu $f3.b1.m -tearoff 0
    $f3.b1.m add command -label [_ "Select"] -command "$cmd same"
    $f3.b1.m add command -label [_ "Select (hide window)"] -command "$cmd small"

    set rpwNode [get_preference_node reports_post_view]
    
    set values ""
    foreach g [gid_groups_conds::give_groups normal "" ""] {
	if { $rpwNode ne "" } {
	    set gr [$rpwNode selectNodes [format_xpath {groups/group[@n=%s]} $g]]
	    if { $gr ne "" } {
		    lappend values [list $g on]
	    } else {
			lappend values [list $g off]
	    }
	} else {
	    lappend values [list $g off]
	}
    }

    cu::menubutton_check_listbox $f3.mb1 -text [_ "Select groups (%d)" 0] -values $values \
	-showbutton 0 -showline 0
    bind $f3.mb1 <<ComboboxSelected>> [list gid_groups_conds::_reports_post_win_update_groups $f3.mb1]
    $w set_uservar_value groups_listbox $f3.mb1
    
    set d [dict create Nodes "$f2.r1" "" "$f2.r1 $f2.r2 $f2.r3"]
    $w enable_disable_on_key enposttype $d
    set d [dict create Nodes "gauss all" default "gauss max"]
    $w change_key_on_key enposttype $d

    set d [dict create all "" sel $f3.b1 groups $f3.mb1]
    $w enable_disable_on_key entities $d
    
    grid $f3.r1  -       -sticky w -padx 4 -pady "10 0"
    grid $f3.r2  $f3.b1  -sticky w -padx 4 -pady 0
    grid $f3.r3  $f3.mb1 -sticky w -padx 4 -pady 0
    grid $f3.cb3    -    -sticky w -padx 4 -pady "10 2"
    
    grid columnconfigure $f3 1 -weight 1
    grid rowconfigure $f3 3 -weight 1

    set f4 [ttk::labelframe $f.f4 -text [_ "output"]]
    
    ttk::radiobutton $f4.r1 -text [_ "View#C#ToView"] -variable [$w give_uservar output] -value view
    ttk::radiobutton $f4.r2 -text [_ "Add to report"] -variable [$w give_uservar output] -value report
    ttk::radiobutton $f4.r3 -text [_ "Export to file"] -variable [$w give_uservar output] -value file

    if { [gid_groups_conds::report_can_add] } {
	grid $f4.r1 $f4.r2 $f4.r3 -sticky w -padx 4 -pady 4
	grid columnconfigure $f4 2 -weight 1
    } else {
	grid $f4.r1 $f4.r3 -sticky w -padx 4 -pady 4
	grid columnconfigure $f4 1 -weight 1
    }
    grid $f1  - -sticky news -padx 2
    grid $f2 $f3 -sticky news -padx 2
    grid $f4  -  -sticky news -padx 2

    grid columnconfigure $f 1 -weight 1
    grid rowconfigure $f 0 -weight 1
	
    set vars [list what_loadcase current gauss max enposttype Nodes entities all \
	    onlywithdata 1 output view]
    if { $rpwNode ne "" } {
	foreach "v def" $vars {
	    $w set_uservar_value $v [$rpwNode @$v $def]
	}
    } else {
	foreach "v def" $vars {
	    $w set_uservar_value $v $def
	}
    }    
    set cmd [list gid_groups_conds::_reports_post_win_update_results $w]
    $w add_trace_to_uservar what_loadcase $cmd
    $w add_trace_to_uservar enposttype $cmd
    $w eval_uservar_traces what_loadcase
    
    tk::TabToWindow $f1.cb1
    bind $w <Return> [list $w invokeok]
    $w createwindow
}

proc gid_groups_conds::reports_post_win_do { w } {
    variable doc
    
    if { [$w giveaction] < 1 } {
	destroy $w
	return
    }
    set d ""
    foreach i [list what_loadcase entities gauss enposttype onlywithdata output] {
	dict set d $i [$w give_uservar_value $i]
    }
    if { [$w give_uservar_value what_loadcase] eq "current" } {
	dict set d loadcase [GiD_Info postprocess get cur_analisis]
    }
    set result_names_dict [$w give_uservar_value result_names_dict]

    set res_listbox [$w give_uservar_value res_listbox]
    set last_parent ""
    set cmpList ""
    set results_tree ""
    foreach v [$res_listbox cget -values] {
	foreach "nameP state parentNameP open_close" $v break
	set name [dict get $result_names_dict $nameP]
	set parentName [dict get $result_names_dict $parentNameP]
	lappend results_tree [list $name $nameP $state $parentName $open_close]
	
	if { $parentName ne "" } {
	    if { $state eq "on" } {
		set last_parentP $parentNameP
		set last_parent $parentName
		lappend cmpList $name
	    }
	} else {
	    if { [llength $cmpList] } {
		dict set d results $last_parent [list $last_parentP $cmpList]
		set cmpList ""
	    }
	}
    }
    if { [llength $cmpList] } {
	dict set d results $last_parent [list $last_parentP $cmpList]
    }
    dict set d results_tree $results_tree

    if { ![dict exists $d results] } {
	snit_messageBox -message [_ "It is necessary to select, at least, one result"] \
	    -parent $w
	return
    }
    switch [$w give_uservar_value entities] {
	all {}
	sel {
	    dict set d selection [$w give_uservar_value selection ""]
	    if { ![llength [dict get $d selection]] } {
		snit_messageBox -message [_ "It is necessary to select entities in the screen"] \
		    -parent $w
		return
	    }
	}
	groups {
	    set groups ""
	    set l [$w give_uservar_value groups_listbox]
	    foreach i [$l cget -values] {
		if { [lindex $i 1] eq "on" } {
		    lappend groups [lindex $i 0]
		}
	    }
	    dict set d groups $groups
	    if { ![llength $groups] } {
		snit_messageBox -message [_ "It is necessary to select, at least, one group"] \
		    -parent $w
		return
	    }
	}
    }
    switch [$w give_uservar_value output] {
	view {
	    _reports_post_view $w $d
	}
	report {
	    if { [$w give_uservar_value entities] eq "sel" } {
		snit_messageBox -message [_ "It is not possible to output entities selection to a report. Choose 'all entities' or 'groups'"] \
		    -parent $w
		return
	    }
	    _reports_post_to_report $w $d
	}
	file {
	    _reports_post_export_file $w $d
	}
    }
    set rpwNode [gid_groups_conds::get_preference_node -clear reports_post_view]
    
    _reports_post_win_from_dict_to_xml $d $rpwNode
}

proc gid_groups_conds::_reports_post_win_from_dict_to_xml { dict domNode } {

    foreach i [list what_loadcase entities gauss enposttype onlywithdata output] {
	$domNode setAttribute $i [dict get $dict $i]
    }
    if { [dict get $dict what_loadcase] eq "current" } {
	$domNode setAttribute loadcase [dict get $dict loadcase]
    }
    set resultsNode [$domNode appendChildTag results]
    foreach v [dict get $dict results_tree] {
	foreach "name nameP state parentName open_close" $v break
	$resultsNode appendChildTag result [list attributes() n $name \
		pn $nameP state $state parentName $parentName open_close $open_close]
    }
    if { [dict get $dict entities] eq "groups" } {
	set groupsNode [$domNode appendChildTag groups]
	foreach group [dict get $dict groups] {
	    $groupsNode appendChildTag group [list attributes() n $group]
	}
    }
}

proc gid_groups_conds::_reports_post_win_from_xml_to_dict { domNode } {
    set dict ""
    
    foreach i [list what_loadcase entities gauss enposttype onlywithdata output] {
	dict set dict $i [$domNode getAttribute $i]
    }
    if { [dict get $dict what_loadcase] eq "current" } {
	dict set dict loadcase [$domNode getAttribute loadcase]
    }
    set results_tree ""
    foreach resNode [$domNode selectNodes results/result] {
	lappend results_tree [list [$resNode @n] [$resNode @pn] [$resNode @state] \
		[$resNode @parentName] [$resNode @open_close]]
    }
    dict set dict results_tree $results_tree
    
    foreach "last_parent last_parentP cmpList" [list "" "" ""] break
    set result_names_dictP ""
    dict set result_names_dictP "" ""
    foreach v $results_tree {
	foreach "name nameP state parentName open_close" $v break
	dict set result_names_dictP $name $nameP
	set parentNameP [dict get $result_names_dictP $parentName]

	if { $parentName ne "" } {
	    if { $state eq "on" } {
		set last_parentP $parentNameP
		set last_parent $parentName
		lappend cmpList $name
	    }
	} else {
	    if { [llength $cmpList] } {
		dict set dict results $last_parent [list $last_parentP $cmpList]
		set cmpList ""
	    }
	}
    }
    if { [llength $cmpList] } {
	dict set dict results $last_parent [list $last_parentP $cmpList]
    }

    set groups ""
    foreach grpNode [$domNode selectNodes groups/group] {
	lappend groups [$grpNode @n]
    }
    dict set dict groups $groups
    
    return $dict
}

proc gid_groups_conds::_reports_post_win_select_entities { w mb window_style } {

    set enposttype [$w give_uservar_value enposttype]
    if { $enposttype eq "All" } {
	snit_messageBox -parent $w -message \
	    [_ "It is necessary to select either nodes or elements"]
	return
    }
    set cmd [list GiD_Process MEscape 'SelectEntities $enposttype]
    set txt [_ "Select entities to list results"]
    select_apply_entities -window_style $window_style $w $cmd $txt
	
    $w add_trace_to_uservar update [list \
	    gid_groups_conds::_reports_post_win_select_entities_end $w $mb]
}

proc gid_groups_conds::_reports_post_win_select_entities_end { w mb } {
    $w remove_traces_to_uservar update
    
    set sel [lrange [string trim $::GidPriv(selection) \"] 1 end]
    $w set_uservar_value selection $sel
    unset ::GidPriv(selection)
    set num 0
    foreach i $sel {
	if { [regexp {(\d+):(\d+)} $i {} n1 n2] } {
	    incr num [expr {$n2-$n1+1}]
	} else { incr num }
    }
    $mb configure -text [_ "Select in screen (%d)" $num]
}

proc gid_groups_conds::_reports_post_win_update_groups { w } {
    
    array set parents ""
    foreach v [$w cget -values] {
	foreach "name state parentName open_close" $v break
	if { $state eq "on" } {
	    if { $parentName ne "" } {
		incr! parents($parentName)
	    } else {
		incr! parents($name)
	    }
	}
    }
    set num [llength [array names parents]]
    $w configure -text [_ "Select groups (%d)" $num]
    
}

proc gid_groups_conds::_reports_post_win_update_results { w } {
    variable doc
    
    set cb [$w give_uservar_value res_listbox]
    
    set old_values [$cb cget -values]
    set values ""
    
    switch [$w give_uservar_value what_loadcase] {
	current { set analyses [list [GiD_Info postprocess get cur_analisis]] }
	default { set analyses [GiD_Info postprocess get all_analisis] }
    }
    switch [$w give_uservar_value enposttype] {
	Nodes { set typelist OnNodes }
	Elements { set typelist OnGaussPoints }
	default { set typelist [list OnNodes OnGaussPoints] }
    }
    set rpwNode [get_preference_node reports_post_view]

    set result_names_dict ""
    dict set result_names_dict "" ""
    foreach curr $analyses {
	set vibrFlag 1
	if {$curr == "_Vibration_modes"} {
	    set vibrFlag 0
	}
	foreach name [GiD_Info postprocess get results_list Contour_Fill $curr $vibrFlag] {
	    regsub {[(][^\)]*[)]$} $name {} nameP
	    regsub -all _ $nameP { } nameP
	    set nameP [string trim $nameP]
	    dict set result_names_dict $nameP $name
	    
	    set ipos [lsearch -exact -index 0 $values $nameP]
	    if { $ipos != -1 } { continue }
	    
	    set type [lindex [GiD_Result get -info [list $name $curr $vibrFlag]] 0 5]
	    if { [lsearch -exact $typelist $type] == -1 } { continue }
	    
	    set xp [format_xpath {results/result[@n=%s]} $name]            
	    set ipos [lsearch -exact -index 0 $old_values $nameP]
	    if { $ipos != -1 } {
		set elm [lindex $old_values $ipos]
	    } elseif { $rpwNode ne "" && [set resNode [$rpwNode selectNodes $xp]] ne "" } {
		set elm [list $nameP [$resNode @state] "" [$resNode @open_close]]
	    } else {
		set elm [list $nameP off "" close]
	    }
	    lappend values $elm
	    
	    foreach c [GiD_Info postprocess get components_list Contour_Fill $name $curr $vibrFlag] {
		dict set result_names_dict $c $c
		set xp [format_xpath {results/result[@n=%s and @parentName=%s]} \
		        $c $name]
		lassign [list 0 0] ipos found
		foreach i $old_values {
		    if { [lindex $i 0] eq $c && [lindex $i 2]  eq $nameP } {
		        set found 1
		        break
		    }
		    incr ipos
		}
		if { !$found } { set ipos -1 }
		if { $ipos != -1 } {
		    set elm [lindex $old_values $ipos]
		} elseif { $rpwNode ne "" && [set resNode [$rpwNode selectNodes $xp]] ne "" } {
		    set elm [list $c [$resNode @state] $nameP [$resNode @open_close]]
		} else {
		    set elm [list $c off $nameP]
		}
		lappend values $elm
	    }
	}
    }
    $w set_uservar_value result_names_dict $result_names_dict
    $cb configure -values $values
}

proc gid_groups_conds::_reports_post_to_report { wp dict } {

    dict set dict create_abbrev_table 1
    set data [gid_groups_conds::create_report_part_xml lognoter reports_post \
	    [_ "Report post"] $dict]

    set cmd [list createpage -ask_user -goto -accept_existing_pages \
	    [= Report]>[_ "Reports post"] - $data ""]
    
    set err [catch { view_report -parent_window $wp -raise_error \
		-execute_commands_after $cmd} errstring]
    if { $err } {
	snit_messageBox -message $errstring -parent $wp
	return
    }        
}

proc gid_groups_conds::_reports_post_export_file { wp dict } {
    
    set reports_post_export_dir [get_preference reports_post_export_dir ""]
    if { ![file isdirectory $reports_post_export_dir] } {
	set reports_post_export_dir [pwd]
    }
    set default_ext [get_preference reports_post_def_extension .xml]
    switch $default_ext {
	".xml" {
	    set types [list \
	    [list [_ "Excel XML files "] ".xml"] \
	    [list [_ "CSV files"] ".csv"] \
	    [list [_ "All files"] "*"] \
	    ]
	}
	default {
	    set types [list \
		    [list [_ "CSV files"] ".csv"] \
		    [list [_ "Excel XML files "] ".xml"] \
		    [list [_ "All files"] "*"] \
	    ]
	}
    }
    set model_name [gid_groups_conds::give_model_name]
    set initial_file "[file tail $model_name]_post_report$default_ext"
    if { $initial_file eq "UNNAMED_post_report$default_ext" } {
	set initial_file "post_report$default_ext"
    }
    set file [tk_getSaveFile -filetypes $types -parent $wp -title \
	    [_ "Export CSV file"] -initialdir $reports_post_export_dir \
	    -initialfile $initial_file -defaultextension $default_ext]
    if { $file == "" } { return }
    set_preference reports_post_export_dir [file dirname $file]
    if { [string equal -nocase [file extension $file] ".xml"] } {
	set_preference reports_post_def_extension ".xml"
    } else {
	set_preference reports_post_def_extension ".csv"
    }
    foreach "namesDict data" [gid_groups_conds::reports_post_give_data $dict] break
    
    set headers [lindex $data 0]
    set rows [lrange $data 1 end]
    
    set fout [open $file w]
    if { [string equal -nocase [file extension $file] ".xml"] } {
	fconfigure $fout -encoding utf-8
	puts $fout {<?xml version="1.0"?>
	    <?mso-application progid="Excel.Sheet"?>
	    <Workbook xmlns="urn:schemas-microsoft-com:office:spreadsheet"
	    xmlns:o="urn:schemas-microsoft-com:office:office"
	    xmlns:x="urn:schemas-microsoft-com:office:excel"
	    xmlns:ss="urn:schemas-microsoft-com:office:spreadsheet"
	    xmlns:html="http://www.w3.org/TR/REC-html40">
	    <Worksheet ss:Name="post report">
	    <Table >}
	puts $fout "<Row>"
	foreach h $headers {
	    puts $fout "<Cell><Data ss:Type='String'>[xml_map $h]</Data></Cell>"
	}
	puts $fout "</Row>"
	foreach row $rows {
	    puts $fout "<Row>"
	    foreach c $row {
		puts $fout "<Cell><Data ss:Type='Number'>[xml_map $c]</Data></Cell>"
	    }
	    puts $fout "</Row>"
	}
	puts $fout "<Row/><Row/>"
	dict for "n v" $namesDict {
	    puts $fout "<Row>"
	    puts $fout "<Cell><Data ss:Type='String'>[xml_map $n]</Data></Cell>"
	    puts $fout "<Cell><Data ss:Type='String'>[xml_map $v]</Data></Cell>"
	    puts $fout "</Row>"
	}
	puts $fout "</Table></Worksheet></Workbook>"
    } else {
	package require csv
	set sep ";"
	puts $fout [csv::join $headers $sep]
	foreach row $rows {
	    puts $fout [csv::join $row $sep]
	}
	puts $fout "\n\n"
	dict for "n v" $namesDict {
	    puts $fout [csv::join [list $n $v] $sep]
	}
    }
    close $fout    
}

proc gid_groups_conds::_reports_post_view { wp dict } {
    
    foreach "namesDict data" [gid_groups_conds::reports_post_give_data $dict] break
    
    set headers [lindex $data 0]
    set rows [lrange $data 1 end]
    
    destroy $wp._ask
    set w [dialogwin_snit $wp._ask -title [_ "Post results"] \
	    -okname -]
    set f [$w giveframe]
    
    set columns ""
    foreach i $headers {
	lappend columns [list 12 $i right text 1]
    }
    lset columns 0 0 6
    
    set f1 [ttk::panedwindow $f.f1 -orient vertical]
    
    package require fulltktree
    fulltktree $f1.tree -width 500 -height 400 -selecthandler2 \
	"[list $w invokeok];#" \
	-columns $columns -expand 0 \
	-selectmode extended -showlines 0 -indent 0 -showbuttons 0 \
	-sensitive_cols all \
	-contextualhandler [list gid_groups_conds::_reports_post_view_contextualmenu $w] \
	-bd 1 -relief solid
    
    foreach row $rows {
	$f1.tree insert end $row
    }
    
    set columns [list \
	    [list 20 [= Name] left text 1] \
	    [list 10 [= Abbr] left text 1] \
	    ]
	
    fulltktree $f1.tree2 -width 500 -height 100 -selecthandler2 \
	"[list $w invokeok];#" \
	-columns $columns -expand 1 \
	-selectmode extended -showlines 0 -indent 0 -showbuttons 0 \
	-sensitive_cols all \
	-contextualhandler [list gid_groups_conds::_reports_post_view_contextualmenu $w] \
	-bd 1 -relief solid

    dict for "n v" $namesDict {
	$f1.tree2 insert end [list $n $v]
    }

    $f1 add $f1.tree
    $f1 add $f1.tree2
    
    if { [gid_groups_conds::report_can_add] } {
	cu::menubutton_button $f.mb -text [_ "Add to report"] -menu $f.mb.m \
	    -command  [list gid_groups_conds::_reports_post_view_output $w report]
	menu $f.mb.m -tearoff 0
	$f.mb.m add command -label [_ "Add to report"] -command \
	    [list gid_groups_conds::_reports_post_view_output $w report]
	$f.mb.m add command -label [_ "Export to file"] -command \
	    [list gid_groups_conds::_reports_post_view_output $w file]
    } else {
	ttk::button $f.mb -text [_ "Export to file"] -command \
	    [list gid_groups_conds::_reports_post_view_output $w file]
    }
    grid $f1 -sticky news -padx 5 -pady 5
    grid $f.mb -sticky e -padx 5 -pady 1
    grid columnconfigure $f 0 -weight 1
    grid rowconfigure $f 0 -weight 1
    
    $w set_uservar_value dict $dict
    
    tk::TabToWindow $f1.tree
    bind $w <Return> [list $w invokecancel]
    set action [$w createwindow]
    destroy $w   
}
    
proc gid_groups_conds::_reports_post_view_output { w output } {

    set dict [$w give_uservar_value dict]
    switch $output {
	report {
	    if { [dict get $dict entities] eq "sel" } {
		snit_messageBox -message \
		    [_ "It is not possible to output entities selection to a report. Choose 'all entities' or 'groups'"] \
		    -parent $w
		return
	    }
	    _reports_post_to_report $w $dict
	}
	file {
	    _reports_post_export_file $w $dict
	}
    }
}

proc gid_groups_conds::_reports_post_view_contextualmenu { w tree items x y } {

    catch { destroy $tree._cmenu }
    set menu [menu $tree._cmenu -tearoff 0]
    
    $menu add command -label [_ "Select all"] \
	-command [list gid_groups_conds::_reports_post_view_contextualmenu_cmd \
	    $tree selectall]
    $menu add separator
    $menu add command -label [_ "Copy"] \
	-command [list gid_groups_conds::_reports_post_view_contextualmenu_cmd \
	    $tree copy]
    $menu add separator
    if { [gid_groups_conds::report_can_add] } {
	$menu add command -label [_ "Add to report"] -command \
	    [list gid_groups_conds::_reports_post_view_output $w report]
    }
    $menu add command -label [_ "Export to file"] -command \
	[list gid_groups_conds::_reports_post_view_output $w file]

    tk_popup $menu $x $y
}

proc gid_groups_conds::_reports_post_view_contextualmenu_cmd { tree what } {

    switch $what {
	selectall {
	    $tree selection add all
	}
	copy {
	    set data ""
	    foreach i [$tree selection get] {
		lappend data [join [$tree item text $i] \t]
	    }
	    clipboard clear
	    clipboard append [join $data \n]
	}
    }
}
    
proc gid_groups_conds::reports_post_give_data { dict } {
    
    set namesDictBase {
	Displacements D
	BDisplacements BD
	"M Reactions" Mr
	Reactions R
	"Y' Shear" Ty'
	"Z' Shear" Tz'
	"Y' Momentus" My'
	"Z' Momentus" Mz'
	"B Axial Force" N
	Torsor T
	"Max Beam Stresses" S
	"Local Axes Beam" LAb
    }
    set namesDict ""
    switch [dict get $dict what_loadcase] {
	current { set analyses [list [dict get $dict loadcase]] }
	default { set analyses [GiD_Info postprocess get all_analisis] }
    }
    set anal [lindex $analyses 0]
    set step 1
    if {$anal == "_Vibration_modes"} {
	set step 0
    }

    set header [list [= Entity]]
    if { [dict get $dict entities] eq "groups" } {
	lappend header [_ "Group"]
    }
    if { [dict get $dict what_loadcase] eq "all" } {
	lappend header [_ "Loadcase"]
    }
    set results [dict keys [dict get $dict results]]
    foreach result $results {
	set res_header "\"$result\" $anal $step"
	set err [catch { GiD_Result get $res_header } r0($anal,$step,$result)]
	if { $err } { continue }
	if { [regexp {^GiD_Result:} $r0($anal,$step,$result)] } { continue }
	foreach "resultP cmpList" [dict get $dict results $result] break
	if { [dict exists $namesDictBase $resultP] } {
	    dict set namesDict $resultP [dict get $namesDictBase $resultP]
	    set resultP [dict get $namesDictBase $resultP]
	}
	set ngauss [expr {[llength [lindex $r0($anal,$step,$result) 2]]-1}]
	set num 0
	foreach cmp $cmpList {
	    dict for "n v" $namesDictBase {
		if { [regexp $n $cmp] } {
		    regsub $n $cmp $v cmp
		    break
		}
	    }

	    switch [dict get $dict gauss] {
		all {
		    incr num $ngauss
		    for { set i 1 } { $i <= $ngauss } { incr i } {
		        set h "${resultP}($cmp)"
		        if { $ngauss > 1 } { append h " ($i)" }
		        lappend header $h

		    }
		}
		maxabs {
		    incr num
		    lappend header "${resultP}($cmp)"
		}
		max {
		    incr num 2
		    lappend header "${resultP}($cmp) (min)" "${result}($cmp) (max)" 
		}
	    }
	}
    }
    set data [list $header]
	
    switch [dict get $dict enposttype] {
	Nodes { set typelist OnNodes }
	Elements { set typelist OnGaussPoints }
	default { set typelist [list OnNodes OnGaussPoints] }
    }

    if { [lsearch -exact $typelist OnNodes] != -1 } { set nodesList "" }
    if { [lsearch -exact $typelist OnGaussPoints] != -1 } { set elemsList "" }
    
    switch [dict get $dict entities] {
	all {
	    if { [lsearch -exact $typelist OnNodes] != -1 } {
		foreach i [GiD_Info Mesh nodes -sublist] {
		    lappend nodesList [lindex $i 0]
		}
	    }
	    if { [lsearch -exact $typelist OnGaussPoints] != -1 } {
		foreach i [GiD_Info Mesh elements Any -sublist] {
		    lappend elemsList [lindex $i 0]
		}
	    }
	}
	sel {
	    if { [lsearch -exact $typelist OnNodes] != -1 } {
		set nodesList [dict get $dict selection]
	    } else {
		set elemsList [dict get $dict selection]   
	    }
	}
	groups {
	    set groups [lsort [dict get $dict groups]]
	    foreach ov [list point line surface volume] {
		foreach j [GiD_Info conditions ${ov}_groups mesh] {
		    foreach "num face - group" $j break
		    if { [lsearch -sorted $groups $group] == -1 } { continue }
		    if { $num eq "E" && [info exists elemsList] } {
		        lappend elemsList [list $face $group]
		    } elseif { $num eq "N"  && [info exists nodesList] } {
		        lappend nodesList [list $face $group]
		    }
		}
	    }
	}
    }
    set idxs [lrepeat [llength $results] 2]
    foreach anal $analyses {
	foreach onWhat [list OnNodes OnGaussPoints] {
	    if { [lsearch -exact $typelist $onWhat] == -1 } { continue }
	    switch $onWhat {
		OnNodes { set entities $nodesList }
		OnGaussPoints { set entities $elemsList }
	    }
	    foreach e $entities {
		if { [regexp {^(\d+):(\d+)$} $e {} n1 n2] } {
		    set range [rangeF $n1 $n2]
		} else { set range [list $e] }
		foreach ent $range {
		    set elm $ent
		    if { [dict get $dict entities] eq "groups" } {
		        set ent_num [lindex $ent 0]
		    } else {
		        set ent_num $ent
		    }
		    if { [dict get $dict what_loadcase] eq "all" } {
		        lappend elm $anal
		    }
		    set iresult 0
		    set num_valid_res 0
		    foreach result $results {
		        if { ![info exists r0($anal,$step,$result)] } {
		            set header "\"$result\" $anal $step"
		            set err [catch { GiD_Result get $header } r0($anal,$step,$result)]
		            if { $err } { continue }
		            if { [regexp {^GiD_Result:} $r0($anal,$step,$result)] } { continue }
		        }
		        set ngauss [expr {[llength [lindex $r0($anal,$step,$result) 2]]-1}]
		        foreach "resultP cmpList" [dict get $dict results $result] break
		        
		        if { [lindex $r0($anal,$step,$result) 0 5] ne $onWhat } {
		            switch [dict get $dict gauss] {
		                all { set num [expr {[llength $cmpList]*$ngauss}] }
		                maxabs { set num [llength $cmpList] }
		                max { set num [expr {[llength $cmpList]*2}] }
		            }
		            eval lappend elm [lrepeat $num ""]
		        } else {
		            set idx [lindex $idxs $iresult]
		            set len [llength $r0($anal,$step,$result)]
		            while { $idx < $len } {
		                if { [lindex $r0($anal,$step,$result) $idx 0] >= $ent_num } { break }
		                incr idx
		            }
		            if { $idx == $len || [lindex $r0($anal,$step,$result) $idx 0] > $ent_num } {
		                switch [dict get $dict gauss] {
		                    all { set num [expr {[llength $cmpList]*$ngauss}] }
		                    maxabs { set num [llength $cmpList] }
		                    max { set num [expr {[llength $cmpList]*2}] }
		                }
		                eval lappend elm [lrepeat $num ""]
		            } else {
		                set cmpList_all [GiD_Info postprocess get components_list \
		                        Contour_Fill $result $anal $step]
		                
		                set cmpNum 0
		                foreach cmp $cmpList {
		                    set cmpNum [lsearch $cmpList_all $cmp]
		                    switch [dict get $dict gauss] {
		                        all {
		                            for { set i 1 } { $i <= $ngauss } { incr i } {
		                                set v [lindex $r0($anal,$step,$result) $idx $i $cmpNum]
		                                lappend elm [nice_number_print $v]                                        }
		                        }
		                        maxabs {
		                            set val ""
		                            for { set i 1 } { $i <= $ngauss } { incr i } {
		                                set v [lindex $r0($anal,$step,$result) $idx $i $cmpNum]
		                                if { $val eq "" || abs($v) > abs($val) } {
		                                    set val $v
		                                }
		                            }
		                            lappend elm [nice_number_print $v]
		                        }
		                        max {
		                            foreach "valmin valmax" [list "" ""] break
		                            for { set i 1 } { $i <= $ngauss } { incr i } {
		                                set v [lindex $r0($anal,$step,$result) $idx $i $cmpNum]
		                                if { $valmin eq "" || $v < $valmin } {
		                                    set valmin $v
		                                }
		                                if { $valmax eq "" || $v > $valmax } {
		                                    set valmax $v
		                                }
		                            }
		                            lappend elm [nice_number_print $valmin] \
		                                [nice_number_print $valmax]
		                        }
		                    }
		                }
		                incr num_valid_res
		            }
		            lset idxs $iresult $idx
		        }
		        incr iresult
		    }
		    if { ![dict get $dict onlywithdata] || $num_valid_res } {
		        lappend data $elm
		    }
		}
	    }
	}
    }
    return [list $namesDict $data]
}





























